const fs = require('fs').promises;
const axios = require('axios');
const path = require('path');

module.exports = {
  config: {
    name: 'segs',
    version: '1.0',
    author: 'JARiF@একটু পাত্তা দওনা চেটে চেটে খাব',
    countDown: 30,
    role: 0,
    category: 'odof',
    guide: {
      vi: '',
      en: 'sdx',
    },
  },

  onStart: async function ({ event, api, args, message }) {
    const prompt = args[0];
    const apiKey = '3d0a1d4c-5251-4643-b094-6c1220745968';
    const randomSeed = Math.floor(Math.random() * 1000000);

    const models = [
      'toonyou_beta6.safetensors [980f6b15]',
      'timeless-1.0.ckpt [7c4971d4]',
      'theallys-mix-ii-churned.safetensors [5d9225a4]',
      'shoninsBeautiful_v10.safetensors [25d8c546]',
    ];

    const imageUrls = [];
    const attachments = [];

    try {
      for (let i = 0; i < models.length; i++) {
        const model = models[i];
        const imageUrl = await generateImage(prompt, model, randomSeed, apiKey);
        imageUrls.push(imageUrl);

        const imageResponse = await axios.get(imageUrl, { responseType: 'arraybuffer' });
        const imageBuffer = Buffer.from(imageResponse.data);

        const modelFilePath = path.join(__dirname, 'cache', `prodia_${randomSeed}_${model}.png`);

        await fs.writeFile(modelFilePath, imageBuffer);

        attachments.push(fs.createReadStream(modelFilePath));
      }

      const names = models.map((model, index) => `${index + 1}. ${model}`).join('\n');

      message.reply({
        body: names,
        attachment: attachments,
      });
    } catch (err) {
      console.error(err);
    }
  },
};

async function generateImage(prompt, model, randomSeed, apiKey) {
  try {
    const options = {
      method: 'POST',
      url: 'https://api.prodia.com/v1/sd/generate',
      headers: {
        accept: 'application/json',
        'content-type': 'application/json',
        'X-Prodia-Key': apiKey,
      },
      data: {
        prompt,
        model,
        negative_prompt: 'sketches,nude, naked, nsfw, boobs, vagina, horny, (worst quality, bad quality, cropped:2.0) ((monochrome)), ((grayscale)), (bad-hands-5:1.0), (badhandv4:1.0), (easynegative:0.8), (bad-artist-anime:0.8), (bad-artist:0.8), (bad_prompt:0.8), (bad-picture-chill-75v:0.8), (bad_prompt_version2:0.8), (bad_quality:0.8)',
        steps: 50,
        cfg_scale: 7,
        seed: randomSeed,
        upscale: false,
        sampler: 'DPM++ 2M Karras',
        aspect_ratio: 'square',
      },
    };

    const response = await axios(options);
    const job = response.data.job;

    while (true) {
      const jobResponse = await axios.get(`https://api.prodia.com/v1/job/${job}`, {
        headers: {
          accept: 'application/json',
          'X-Prodia-Key': apiKey,
        },
      });

      if (jobResponse.data.status === 'succeeded') {
        const imageUrl = jobResponse.data.imageUrl;
        return imageUrl;
      }

      await new Promise((resolve) => setTimeout(resolve, 500));
    }
  } catch (err) {
    console.error(err);
    throw err;
  }
}
