const axios = require("axios");

module.exports = {
  config: {
    name: "pixart",
    countDown: 15,
    category: "AI",
    role: 0,
    guide: {
      en: `{pn} prompt with models and ratio's \n Available Models: 1. Base\n2. Cinematic\n3. Photographic\n4. Anime\n5. Manga\n6. Digital Art\n7. Pixel Art\n8. Fantasy Art\n9. Neonpunk\n10. 3D Model
Available Ratio's:
1. Square
2. Horizontal
3. Vertical\nExample: {pn} cute girl | 2 | 3`
    }
  },

onStart: async function ({ api, args, event, message }) {
  
  try {
    setTimeout(() => {
      message.reaction("⏳", event.messageID);
    }, 700);

   message.reply("✅ | Processing your image......")

    const text = args.join(" ");

    if (!text) {
      return message.reply("Please provide a prompt.");
    }

    let prompt, model, ratio;
    if (text.includes("|")) {
      const [promptText, modelText, ratioText] = text.split("|").map((str) => str.trim());
      prompt = promptText;
      model = modelText;
      ratio = ratioText;
    } else {
      prompt = text;
      model = "1";
      ratio = "1";
    }
 
      const response = await axios.post(
        'https://api.replicate.com/v1/predictions',
        {
          'version': '816c99673841b9448bc2539834c16d40e0315bbf92fef0317b57a226727409bb',
          'input': {
            'prompt': prompt,
            'negative_prompt': 'low quality, bad anatomy, 3D, CGI, deformed',
            'style': getModelText(model),
            'width': getWidth(ratio),
            'height': getHeight(ratio),
            'num_outputs': 4,
            'guidance_scale': 6,
            'num_inference_steps': 35
          }
        },
        {
          headers: {
            'Content-Type': 'application/json',
            'Authorization': 'Token r8_80lNb8AwpEemw9n39hGmIaUKvwF86WG3ruxIG'
          },
          validateStatus: status => true
        }
      );

      const getUrl = response.data.urls.get;

      let output = null;
      while (!output) {
        const poll = await axios.get(getUrl, { headers: { 'Authorization': 'Token r8_80lNb8AwpEemw9n39hGmIaUKvwF86WG3ruxIG' } });
        output = poll.data.output;
      }
     let streams = [];
     for (let i of output) {
         const s = await global.utils.getStreamFromURL(i);
         streams.push(s);
        }   

      await message.reply({
        body: "✅ | Image successfully generated.",
        attachment: streams,
      });

    } catch (error) {
      console.error(error);
      await message.reply(`Error: ${error}`);
    }
  },
};

function getModelText(model) {
  const models = ["None", "Cinematic", "Photographic", "Anime", "Manga", "Digital Art", "Pixel Art", "Fantasy Art", "Neonpunk", "3D Model"];
  return models[model - 1] || "None";
}

function getWidth(ratio) {
  const widths = [1024, 1280, 720];
  return widths[ratio - 1] || 1024;
}

function getHeight(ratio) {
  const heights = [1024, 720, 1280];
  return heights[ratio - 1] || 1024;
}