const fs = require('fs-extra');

module.exports = {
  config: {
    name: "approve",
    version: "1.4",
    author: "Mahir Tahsan",
    countDown: 0,
    role: 2,
    shortDescription: "Approve or delete a thread",
    longDescription: "",
    category: "admin",
    guide: {
      en: "List of Action: add, delete, list\n{p}{n} <action> <threadID>"
    }
  },
   langs: {
		en: {
			unavailable: "⚠ The Thread you provided isn't Available",
			already: " ⚔️ | This threadID is already approved.",
			unapproved: "🪪 | This threadID is not found in database",
			successful: "Successfully Approved ✅\n\n❏ Name: %1 \n❏ Tid: %2",
			delete: "Successfully Deleted ⛔\n\n❏ Name: %1 \n❏ Tid: %2"
		}
	},

  onStart: async function ({ api, args, message, event, threadsData, usersData, getLang }) {
    if (!args || args.length < 1) {
  		return message.reply("Baka provide an action (add - delete or list) 🐤");
}
    const action = args[0].toLowerCase();
    const threadID = args[1];

    try {
      let filepath = JSON.parse(fs.readFileSync('groups.json'));

if (action === "add") {
    const threadData = threadsData.get(threadID);
    if (!threadData) {
        message.reply(getLang("unavailable"));
        return;
    }
    const threadInfo = await api.getThreadInfo(threadID);

    if (!threadInfo) {
        return message.reply(getLang("unavailable"));
    }

    const threadName = threadInfo.threadName;
    if (filepath.includes(threadID)) {
        return message.reply(getLang("already"));
    }
    filepath.push(threadID);

    fs.writeFileSync('groups.json', JSON.stringify(filepath, null, 2));
    message.reply(getLang("successful", threadName, threadID));
} else if (action === "delete") {
    const index = filepath.indexOf(threadID);
    if (index === -1) {
        return message.reply(getLang("unapproved"));
    }
    const threadInfo = await api.getThreadInfo(threadID);

    if (!threadInfo) {
        return message.reply(getLang("unavailable"));
    }

    const threadName = threadInfo.threadName;

    filepath.splice(index, 1);

    fs.writeFileSync('groups.json', JSON.stringify(filepath, null, 2));

    message.reply(getLang("delete", threadName, threadID));

      } else if (action === "list") {
        let threadList = "⋆⏤‌ Approved threads ⏤‌⋆\n\n";
  for (let i = 0; i < filepath.length; i++) {
    const threadId2 = filepath[i];
    const threadData2 = threadsData.get(threadId2);
    	if (!threadData2) {
      		message.reply(getLang("unavailable"));
      	return;
    	}
    const threadInfo2 = await api.getThreadInfo(threadId2);
          if (!threadInfo2) {
            throw new Error("Thread info not found.");
          }
    const threadName2 = threadInfo2.threadName;

    threadList += `• ┌ Name: ${threadName2}\n• └ ID: ${threadId2}\n`;
  }

        message.reply(threadList);
      } else {
        message.reply("Invalid action. Please use 'add', 'delete', or 'list'.");
      }
    } catch (error) {
      console.error(error);
      message.error(error);
      //message.reply("An error occurred while processing your request. Please try again later.");
    }
  }
};