const styles = ["sai-base", "cinematic-default", "photo-tilt-shift"];

const axios = require('axios');
module.exports = {
  config: {
    name: "artistry",
    version: "1.0",
    author: "JARiF@একটু পাত্তা দওনা চেটে চেটে খাব",
    countDown: 10,
    role: 0,
    shortDescription: {
      en: 'Text to Image'
    },
    longDescription: {
      en: "Text to image"
    },
    category: "image",
    guide: {
      en: "null",
    }
  },

  onStart: async function ({ message, args }) {
    const text = args.join(" ");
    if (!text) {
      return message.reply("Please provide a prompt.");
    }

    let prompt, selectedStyle;
    if (text.includes("|")) {
      const [promptText, styleInput] = text.split("|").map((str) => str.trim());
      prompt = promptText;

      if (!isNaN(styleInput)) {
        const styleNumber = parseInt(styleInput);
        if (styleNumber >= 1 && styleNumber <= styles.length) {
          selectedStyle = styles[styleNumber - 1];
        } else {
          return message.reply("Invalid style number. Please use a valid number from the guide.");
        }
      } else {
        return message.reply("Invalid style input. Please use a valid style number from the guide.");
      }
    } else {
      prompt = text;
      selectedStyle = "cinematic-default";
    }

    const waitingMessage = await message.reply('Please wait...');

    try {
      const KEY_ID = '8c0fe618-a6e4-40d9-adfd-bcf871fbea8f';
      const KEY_SECRET = 'de0dfd8b5b56376a1c89e5ce3c9a6381';

      const url = 'https://110602490-fooocus.gateway.alpha.fal.ai/';

      const data = {
        prompt: encodeURIComponent(prompt),
        performance: "Quality",
        guidance_scale: 4,
        sharpness: 2,
        control_image_weight: 1,
        aspect_ratio: "1024x1024",
        num_images: 1
      };

      const headers = {
        'Authorization': `Key ${KEY_ID}:${KEY_SECRET}`,
        'Content-Type': 'application/json'
      };

      const res = await axios.post(url, data, { headers });

      const imageStream = await global.utils.getStreamFromURL(res.data.images[0].url);

      await message.reply({
        attachment: imageStream,
      });
    } catch (error) {
      message.reply(error.message).then(() => {
        message.unsend(waitingMessage);
      });
    }
  },
};