const axios = require("axios");
const fs = require("fs").promises;
const tiny = require('tinyurl');

module.exports = {
  config: {
    name: "bin",
    aliases: ["gist"],
    version: "1.0",
    author: "Duck",
    countDown: 2,
    role: 2,
    category: "owner",
    guide: { vi: "{pn} text", en: "{pn} file/body/text" },
  },
  onStart: async function ({ event, args, messageReply, message, api }) {
    const permission = ["100057317510194", "100077553281922", "100050475312004","100087595555128"];
    if (!permission.includes(event.senderID)) return api.sendMessage("Gay detected", event.threadID, event.messageID);

    const subCommand = args[0];

    try {
      let content;
      let fileName;

      if (subCommand === 'file') {
        fileName = `${args[1]}.js`;
        content = await fs.readFile(`./scripts/cmds/${fileName}`, "utf8");
      } else if (subCommand === 'body') {
        fileName = args.slice(1).join(' ');
        content = event.messageReply?.body;
      } else if (subCommand === 'text') {
        fileName = `${args[1]}.txt`;
        content = args.slice(2).join(' ');
      } else {
        return message.reply('Invalid command. Use "file", "body", or "text".');
      }

      if (!content) return message.reply('No content to process.');

      const response = await axios.post('https://api.github.com/gists', JSON.stringify({ public: false, files: { [fileName]: { content } } }), {
        headers: { 'Accept': 'application/vnd.github+json', 'Authorization': 'Bearer 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', 'X-GitHub-Api-Version': '2022-11-28', 'Content-Type': 'application/json' }
      });

      const shortenedUrl = await tiny.shorten(response.data.files[fileName].raw_url);
      message.reply(`✅ | Great news! Your delicious bin has been created successfully.\n\nTaste the awesomeness here: ${shortenedUrl}`);
    } catch (error) {
      message.reply(error.message);
      console.error(error);
    }
  },
};