const axios = require('axios');
const fs = require('fs-extra');
const path = require('path');

module.exports = {
  config: {
    name: "bing",
    aliases: ["dalle3"],
    version: "1.0",
    author: "JARiF",
    countDown: 15,
    role: 0,
    shortDescription: "Generate images by Dalle3",
    longDescription: "Generate images by Dalle3",
    category: "download",
    guide: {
      en: "{pn} prompt"
    }
  },

  onStart: async function ({ api, event, message, args }) {
    try {
      const p = args.join(" ");

      const waitingMessage = await message.reply("Please wait...");

const cookie = "1Bs2SS_-0F0n98jKjQ_HNgaDxmlCCNB0FnFF2IFev8cuf6CA5ub85G7dDeqjcUMgllg6EFx5gnJsanqXtJmWwMPejdUdPP2rHJJdVZx4JPh0ZlhsEvSn7wYteZE99867mcJq4-t9fDyMdJCHtAq3K0V1vEw1rILm9YLdyCyRqZLnGvidxTqo-UjfHtAcKPq63WuTwduDqJIKlo8Et6JtxPkSu8jj8CE9TqvKM4ME8yHc";
      const url = `https://dallegay.onrender.com/api/dalle?prompt=${p}&cookie=${encodeURIComponent(cookie)}`;
      
      const response = await axios.get(url);
      const data = response.data.image_urls;
      const time = response.data.time_taken;
      const imgData = [];

      for (let i = 0; i < data.length; i++) {
        const imgResponse = await axios.get(data[i], { responseType: 'arraybuffer' });
        const imgPath = path.join(__dirname, 'cache', `${i + 1}.jpg`);
        await fs.outputFile(imgPath, imgResponse.data);
        imgData.push(fs.createReadStream(imgPath));
      }

      await message.reply({
        body: `✅ | Generated\Your Prompt: ${p}\\Time taken: ${time} seconds `,
        attachment: imgData
      });

    } catch (error) {
      console.error(error);
      return message.reply(error.message);
    }
  }
};