const axios = require('axios');
const fs = require('fs-extra');

module.exports = {
  config: {
    name: "japan",
    version: "1.6",
    author: "Samir Œ",
    countDown: 5,
    role: 0,
    category: "Fun",
    ShortDescription: "text to voice",
    LongDescription: "bot will make your text into voice.",
    guide: {
      en: ""
    }
  },

  onStart: async function ({ api, args, message, event }) {
    const { getPrefix } = global.utils;
    const p = getPrefix(event.threadID);

    let text;

    if (event.type === "message_reply") {
      text = event.messageReply.body;
    } else {
      text = args && args.length > 0 ? args.join(" ") : '';
    }

    if (!text) {
      return message.reply(`provide some text 🫵\n\nExample:\n${p}say hi there`);
    }

    const path = "./tts.mp3";
    const urlPrefix = "https://midjourney.brokenx69.repl.co/tts/jp?text=";

    try {
      if (text.length <= 150) {
        const response = await axios({
          method: "get",
          url: `${urlPrefix}${encodeURIComponent(text)}`,
          responseType: "stream"
        });

        const writer = fs.createWriteStream(path);
        response.data.pipe(writer);
        writer.on("finish", () => {

          message.reply({
            body: text,
            attachment: fs.createReadStream(path)
          }, () => {
            fs.remove(path);
          });
        });
      } else {
        const chunks = text.match(/.{1,150}/g);

        for (let i = 0; i < chunks.length; i++) {
          const response = await axios({
            method: "get",
            url: `${urlPrefix}${encodeURIComponent(chunks[i])}`,
            responseType: "stream"
          });

          const writer = fs.createWriteStream(path, { flags: i === 0 ? 'w' : 'a' });
          response.data.pipe(writer);

          if (i === chunks.length - 1) {
            writer.on("finish", () => {
              
              message.reply({
                body: text,
                attachment: fs.createReadStream(path)
              }, () => {
                fs.remove(path);
              });
            });
          }
        }
      }
    } catch (err) {
      console.error(err);
      message.reply("An error occurred while trying to convert your text to speech or send it as an attachment. Please try again later.");
    }
  }
};