
const axios = require('axios');

module.exports = {
  config: {
    name: "bornapi",
    aliases: ["search"],
    category: "goatBot",
    role: 0,
    shortDescription: {
      en: "Search API",
      tl: "Maghanap gamit ang API"
    },
    longDescription: {
      en: "Search API using provided URL",
      tl: "Maghanap gamit ang ibinigay na URL"
    },
    guide: {
      en: "{p}searchAPI <query>",
      tl: "{p}searchAPI <query>"
    }
  },

  onStart: async function ({ event, message, args }) {
    // Get the query from the arguments
    const query = args.join(" ");
    
    // Replace {prompt} in the URL with the query
    const url = `https://www.eporner.com/api/v2/video/search/?query=${encodeURIComponent(query)}&per_page=1&page=1&thumbsize=big&order=top-weekly&gay=1&lq=1&format=json`;

    try {
      // Make the API request
      const response = await axios.get(url);

      // Access the data from the response
      const data = response.data;

      // Handle the data and send a response
      // You can access and manipulate the data here according to your needs
      
      // Example: Log the response data
      console.log(data);
      
      // Example: Send the response to the user
      message.reply("Here is the search API response: " + JSON.stringify(data));
    } catch (error) {
      // Handle any errors that occur during the API request
      console.error(error);
      message.reply("An error occurred while making the API request.");
    }
  }
};