const axios = require('axios');

module.exports = {
  config: {
    name: 'cat',
    version: '1.0',
    author: 'Eijah Noah',
    category: 'utility',
    shortDescription: { en: 'cat' }
  },
  onStart: async function ({ message }) {
    try {
      const [a, b] = await Promise.all([
        axios.get('https://api.thecatapi.com/v1/images/search'),
        axios.get('https://catfact.ninja/facts')
      ]);

      const imageURL = a.data[0].url;
      const factText = b.data.data[0].fact;

      const stream = await global.utils.getStreamFromURL(imageURL);

      message.reply({
        body: factText,
        attachment: stream
      });
    } catch (error) {
     message.reply(error.message);
    }
  }
};