const axios = require('axios');
const fs = require('fs');
const path = require('path');
const tracker = {};

module.exports = {
  config: {
    name: "cgi",
    version: "1.0",
    author: "Samir Œ",
    countDown: 5,
    role: 0,
    longDescription: "most advanced ai",
    category: "𝗔𝗜",
    guide: { en: "{pn} <query>" },
  },

  clearHistory: function () {
    global.GoatBot.onReply.clear();
  },

onStart: async function ({ message, event, args, usersData }) {
    const prompt = args.join(' ');
    const userName = await usersData.getName(event.senderID);
    const userID = event.senderID;

    if (!args[0]) return message.reply('Please enter a query.');
    if (args[0] === 'clear') {
      this.clearHistory();
      const c = await clean(userID);
      if (c) return message.reply('Conversation history cleared.');
    }

    if (!tracker[userID]) {
      tracker[userID] = `${userName}.\n`;
    }
    tracker[userID] += `${prompt}.\n`;

    try {
      let query = `- Current prompt: ${prompt}\n\n - Conversation:\n${tracker[userID]}\n`;
      let url = `https://apis-samir.onrender.com/SamirAi/v2?text=${encodeURIComponent(query)}`;

      if (event.type === "message_reply") {
        const imageLink = event.messageReply?.attachments?.[0]?.url;
        if (imageLink) {
          const imgurResponse = await axios.get(`${global.api.samirApi}/telegraph?url=${encodeURIComponent(imageLink)}&senderId=${event.senderID}`);
          const imgur = imgurResponse.data.result.link;
          url = `https://apis-samir.onrender.com/SamirAi/v2?text=${encodeURIComponent(query)}&url=${imgur}`;
        }
      }

      const response = await axios.get(url, {
        headers: {
          'Content-Type': 'application/json',
        },
      });
      const resultText = response.data.result;
      tracker[userID] += `${resultText}`;

      const ttsPath = "./tts.mp3";
      const number = Math.floor(Math.random() * 10);

      try {
        if (resultText.length <= 150) {
          const ttsResponse = await axios({
            method: "get",
            url: `https://apis-samir.onrender.com/ttv?text=${encodeURIComponent(resultText)}&melody=${number}&apikey=helloWorld69`,
            responseType: "stream"
          });
          const writer = fs.createWriteStream(ttsPath);
          ttsResponse.data.pipe(writer);
          writer.on("finish", () => {
            message.reply({
              body: resultText,
              attachment: fs.createReadStream(ttsPath)
            }, (error, info) => {
              global.GoatBot.onReply.set(info.messageID, {
                commandName: this.config.name.toLowerCase(),
                author: userID
              });
              fs.unlink(ttsPath, (err) => {
                if (err) console.error(err);
              });
            });
          });
        } else {
          const chunkSize = 150;
          const chunks = resultText.match(new RegExp(`.{1,${chunkSize}}`, 'g'));
          for (let i = 0; i < chunks.length; i++) {
            const ttsResponse = await axios({
              method: "get",
              url: `https://apis-samir.onrender.com/ttv?text=${encodeURIComponent(chunks[i])}&melody=${number}&apikey=helloWorld69`,
              responseType: "stream"
            });
            const writer = fs.createWriteStream(ttsPath, { flags: i === 0 ? 'w' : 'a' });
            ttsResponse.data.pipe(writer);
            if (i === chunks.length - 1) {
              writer.on("finish", () => {
                message.reply({
                  body: resultText,
                  attachment: fs.createReadStream(ttsPath)
                }, (error, info) => {
                  global.GoatBot.onReply.set(info.messageID, {
                    commandName: this.config.name.toLowerCase(),
                    author: userID
                  });
                  fs.unlink(ttsPath, (err) => {
                    if (err) console.error(err);
                  });
                });
              });
            }
          }
        }
      } catch (err) {
        console.error(err);
        message.reply("An error occurred while trying to convert your text to speech or send it as an attachment. Please try again later.");
      }
    } catch (error) {
      console.error(error);
      message.reply("An error occurred.");
    }
  },


  onReply: async function ({ Reply, message, event, args, usersData }) {
    let { author } = Reply;
    if (author !== event.senderID) return;

   const prompt = args.join(' ');
     const userID = event.senderID;
    const userName = await usersData.getName(event.senderID);

    tracker[userID] += `${prompt}.\n`;

    try {
      let query = `- Current prompt: ${prompt}\n\n - Conversation:\n${tracker[userID]}\n`;
      let url = `https://apis-samir.onrender.com/SamirAi/v2?text=${encodeURIComponent(query)}`;

      const response = await axios.get(url, {
        headers: {
          'Content-Type': 'application/json',
        },
      });
      const resultText = response.data.result;
      tracker[userID] += `${resultText}`;

      const ttsPath = "./tts.mp3";
      const number = 1;

      try {
        if (resultText.length <= 150) {
          const ttsResponse = await axios({
            method: "get",
            url: `https://apis-samir.onrender.com/ttv?text=${encodeURIComponent(resultText)}&melody=${number}&apikey=helloWorld69`,
            responseType: "stream"
          });
          const writer = fs.createWriteStream(ttsPath);
          ttsResponse.data.pipe(writer);
          writer.on("finish", () => {
            message.reply({
              body: resultText,
              attachment: fs.createReadStream(ttsPath)
            }, (error, info) => {
              global.GoatBot.onReply.set(info.messageID, {
                commandName: this.config.name.toLowerCase(),
                author: userID
              });
              fs.unlink(ttsPath, (err) => {
                if (err) console.error(err);
              });
            });
          });
        } else {
          const chunkSize = 150;
          const chunks = resultText.match(new RegExp(`.{1,${chunkSize}}`, 'g'));
          for (let i = 0; i < chunks.length; i++) {
            const ttsResponse = await axios({
              method: "get",
              url: `https://apis-samir.onrender.com/ttv?text=${encodeURIComponent(chunks[i])}&melody=${number}&apikey=helloWorld69`,
              responseType: "stream"
            });
            const writer = fs.createWriteStream(ttsPath, { flags: i === 0 ? 'w' : 'a' });
            ttsResponse.data.pipe(writer);
            if (i === chunks.length - 1) {
              writer.on("finish", () => {
                message.reply({
                  body: resultText,
                  attachment: fs.createReadStream(ttsPath)
                }, (error, info) => {
                  global.GoatBot.onReply.set(info.messageID, {
                    commandName: this.config.name.toLowerCase(),
                    author: userID
                  });
                  fs.unlink(ttsPath, (err) => {
                    if (err) console.error(err);
                  });
                });
              });
            }
          }
        }
      } catch (err) {
        console.error(err);
        message.reply("An error occurred while trying to convert your text to speech or send it as an attachment. Please try again later.");
      }
    } catch (error) {
      console.error(error);
      message.reply("An error occurred.");
    }
  }
};

async function clean(userID) {
  if (tracker[userID]) {
    delete tracker[userID];
    return true;
  }
  return false;
}