
const axios = require('axios');

module.exports = {
  config: {
    name: "clips",
    version: "1.1",
    author: "JiRAF",
    shortDescription: { en: "T" },
    longDescription: { en: "T" },
    category: "video",
    countDown: 10,
    role: 0,
    guide: { en: "{pn} <prompt>" }
  },

  onStart: async function ({ api, event, args, message }) {
    const clips = [];

    const prompt = args.join(' ');
    if (!prompt) {
      return message.reply("Please provide a prompt.");
    }
    api.setMessageReaction("⏰", event.messageID, () => {}, true);

    try {
      const response = await axios.get(`https://www.annie-jarif.repl.co/rktim-gay?prompt=${encodeURIComponent(prompt)}`);
      const urls = response.data.videoUrls;
      if (urls && urls.length > 0) {
        clips.push(...urls);
      }
      const clipCount = clips.length;

      message.reply({
        body: `Here's your requested clip: ${prompt}\nTotal clips: ${clipCount}\n\nYou can reply with "next" for another one.`,
        attachment: await global.utils.getStreamFromURL(clips[0])
      }, async (err, info) => {
        if (err) {
          console.error(err);
          api.sendMessage(`Error: ${err}`, event.threadID);
          return;
        }

        api.setMessageReaction("✅", info.messageID, () => {}, true);
        global.GoatBot.onReply.set(info.messageID, {
          commandName: this.config.name,
          messageID: info.messageID,
          author: event.senderID,
          urls: clips
        });
      });
    } catch (error) {
      console.error(error);
      api.sendMessage(`Sorry, an error occurred while fetching clips.`, event.threadID);
    }
  },

  onReply: async function ({ api, event, Reply, message }) {
    let { author, messageID, urls } = Reply;
    let { body } = event;

    if (event.senderID !== author) return;

    if (body.toLowerCase() === "next") {
      try {
        const allClip = urls.slice(1);
        const clipCount = urls.length;

        if (clipCount > 0) {
          const clip = await global.utils.getStreamFromURL(allClip[0]);

          message.reply({
            body: `Here's your next clip (${clipCount - 1} remaining):`,
            attachment: clip
          }, (err, info) => {
            if (err) {
              console.error(err);
              api.sendMessage(`Error: ${err}`, event.threadID);
              return;
            }
            global.GoatBot.onReply.set(info.messageID, {
              commandName: this.config.name,
              messageID: info.messageID,
              author: event.senderID,
              urls: urls.slice(1)
            });
          });
        } else {
          message.reply("No more clips available.");
        }
      } catch (error) {
        console.error(error);
        api.sendMessage(`Error: ${error}`, event.threadID);
      }

      message.unsend(Reply.messageID);
    }
  }
};