const axios = require('axios');
const FormData = require('form-data');

module.exports = {
  config: {
    name: "sopno",
    version: "1.0",
    author: "JARiF@একটু পাত্তা দওনা চেটে চেটে খাব",
    countDown: 5,
    role: 0,
    shortDescription: {
      vi: "Chuyển đổi văn bản thành hình ảnh",
      en: "Convert text to an image"
    },
    longDescription: {
      vi: "Lệnh này chuyển đổi một đoạn văn bản thành hình ảnh bằng cách sử dụng Text to Image API.",
      en: "This command converts a given text into an image using the Text to Image API."
    },
    category: "Image",
    guide: {
      vi: "Sử dụng lệnh `sopno` để chuyển đổi văn bản thành hình ảnh.\nSử dụng: `sopno <văn_bản>`",
      en: "Use the `sopno` command to convert text to an image.\nUsage: `sopno <text>`"
    }
  },

  onStart: async function ({ api, args, event }) {
    const apiKey = 'b034e856cde14fe257caf00aadbb0e69cd5cd5e90d6c33db18b30d4b03203859f53383f47dccb063167a8355c63f7fcf';
    const url = 'https://clipdrop-api.co/text-to-image/v1';

    const promptText = args.join(' ');

    const formData = new FormData();
    formData.append('prompt', promptText);

    try {
      const response = await axios.post(url, formData, {
        headers: {
          'Content-Type': 'multipart/form-data',
          'x-api-key': apiKey
        },
        responseType: 'arraybuffer'
      });

      const imageData = Buffer.from(response.data, 'binary');

      api.sendMessage({
        attachment: imageData,
        filename: 'generated_image.png'
      }, event.threadID);
      
      console.log('Image generated successfully!');
    } catch (error) {
      console.log('An error occurred:', error.message);
      api.sendMessage('Error: Image generation failed', event.threadID);
    }
  }
};