const { getStreamFromURL, uploadImgbb } = global.utils;
const fs = require("fs").promises;
const path = require('path');
const short = require('tinyurl');
const axios = require("axios");

const API = 'https://midjourney-pv6b.onrender.com';
const Base = "https://api.midjourneyapi.xyz/mj/v2/";
const webhookOptions = { webhook_endpoint: "", webhook_secret: "" };
const apiKeys = [
  "b838b2fa8b732e8800c8545aa6ff461f39fea5b3511e685622fa8986ab7797f5",
  "96c4bb905be659b693dd2d0ad1746bd622e0d69d8562ed9f704f5842974f2add",
  "af6619099fb108e462fdc58aa2916a26515a0e2e3c0af6c2a557b302add87370",
  "dd5f553a04bcec71f3334145dd76253447ad71c9c5515ba7ff0fe709519e5daa",
  "094ff2a7459f6f29a6678c6d8c7e4d3dc46488c7dcb5b6ec218b67c4f3563c45",
  "f51619f44637f3b1d5f20e3bc3a42a712c16cc2d752904d5f5309c3eedd06332",
  "fbb2963ad70d6f8cbd7713d5cecb87377df0b57542275d04e0bab932939cabb8",
  "15d5632effadbe64df4ae7e2b1fa2ac6d872d781318f5229c2805e13bd1e4c95",
  "98e35ba481a1185ff2a04f2accc0d8a94f0d030bd34e7a2a92d6beaf5580c49d",
  "b4ed8ba1ba63d48244f65312365eb82ac44a58eeeaebccd64849b915a180381f"
];
let currentApiKeyIndex = 0;


async function saveData(resultData, count, name) {
  const resultFilePath = path.join('resultData.json');

  try {
    const existingData = await fs.readFile(resultFilePath, 'utf-8');
    const parsedData = JSON.parse(existingData);
    parsedData[count] = { name, ...resultData };
    await fs.writeFile(resultFilePath, JSON.stringify(parsedData, null, 2));
  } catch (error) {
    const newData = { [count]: { name, ...resultData } };
    await fs.writeFile(resultFilePath, JSON.stringify(newData, null, 2));
  }
}


module.exports = {
  config: {
    name: "dickx",
    version: "1.0",
    author: "Akash Xzh",
    cooldown: 50,
    role: 0,
    longDescription: "Generate unique and captivating images using the Midjourney API. Combine prompts and optional image attachments to create visually stunning results.",
    category: "ai imagination",
    guide: { en: "Usage: {pn} prompt or {pn} imageReply + prompt." },
  },

  onStart: async function ({ api,  args, event, message }) {
    try {
    const permission = [ "100032778441480", "100077553281922", "100066407270658", "100080352260736", "100070029543010", "100017822257155",
"100087595555128"];

if (!permission.includes(event.senderID)) {
  api.sendMessage("~OhBaka!Seemsyoudon'thavepermissiontousethiscmd!🐱", event.threadID, event.messageID);
  return;
}
      let apiReqUrl;
      let requestData;
      const apiKeyX = '50ceb33125551fb67ed017b4bf83418b5382448590fb84af73f7e5bc1a8e4eb6';
      if (args[0] === "info") {
        const countID = args[1];
        const resultFilePath = path.join('resultData.json');

          const existingData = await fs.readFile(resultFilePath, 'utf-8');
          const parsedData = JSON.parse(existingData);

       if (parsedData[countID]) {
         const timestamp = parseInt(parsedData[countID].meta.created_at);
const date = new Date(timestamp * 1000);
const options = {
  year: 'numeric',
  month: '2-digit',
  day: 'numeric',
  hour: 'numeric',
  minute: 'numeric',
  second: 'numeric',
  hour12: true,
  timeZone: 'Asia/Dhaka'
};
const formattedDate = date.toLocaleString('en-US', options);

         const data = 'Info for ID ' + countID + '\n\n' +
  'Prompt: ' + (parsedData[countID]?.meta.task_request?.prompt || 'N/A') + '\n\n' +
  'Created at: ' + formattedDate + '\n' + 'Created by: ' + (parsedData[countID]?.name || 'N/A') + '\n' +
  'Process mode: ' + (parsedData[countID]?.meta?.process_mode || 'N/A') + '\n' +
  'Process time: ' + parsedData[countID]?.process_time + ' seconds\n' +
  'I2I: ' + (parsedData[countID]?.meta?.task_request?.upload_prompt_image !== undefined ?
          parsedData[countID]?.meta?.task_request?.upload_prompt_image : 'N/A') + '\n' +
  'Q: ' + (parsedData[countID]?.task_result?.quota_used || 'N/A') + '%';

         const replyOptions = {
           body: data,
         };

         if (parsedData[countID].task_result.image_url) {
  replyOptions.attachment = await getStreamFromURL(parsedData[countID].task_result.image_url);
         }
         return message.reply(replyOptions);
          } else {
           return message.reply(`No info found for ID ${countID}`);
       }
     } else if (args[0] === "delete") {
  const id = args[1];
  const resultFilePath = path.join('resultData.json');

   try {
    const existingData = await fs.readFile(resultFilePath, 'utf-8');
    const parsedData = JSON.parse(existingData);

    if (parsedData[id]) {
      delete parsedData[id];

      await fs.writeFile(resultFilePath, JSON.stringify(parsedData, null, 2));

      return message.reply(`Data with ID ${id} deleted successfully.`);
    } else {
      return message.reply(`Data with ID ${id} not found.`);
    }
  } catch (error) {
    console.error('Error deleting data:', error);
  }
} else if (args[0] === "blend") {
        let imageURLs = [];

        if (event.type === "message_reply") {
          if (!event.messageReply.attachments || (event.messageReply.attachments.length && event.messageReply.attachments.length <= 2)) {
            throw new Error("Please reply to a message with a minimum of 2 and up to 4 images...!");
          }

          for (let i = 0; i < Math.min(event.messageReply.attachments.length, 4); i++) {
            if (["photo", "sticker"].includes(event.messageReply.attachments[i]?.type)) {
              const imageUrl = await short.shorten(event.messageReply.attachments[i].url);
              imageURLs.push(imageUrl);
            }
          }

          if (!imageURLs.length) {
            throw new Error("No valid attachments found.");
          }

          apiReqUrl = Base + 'blend';
          requestData = {
            image_urls: imageURLs,
            process_mode: 'relax',
            aspect_ratio: '1:1',
            ...webhookOptions
          };
        }
      } else {
        let imageUrl = null;

        if (event.type === "message_reply" && ["photo", "sticker"].includes(event.messageReply.attachments?.[0]?.type)) {
          const s = await uploadImgbb(event.messageReply.attachments[0].url);
    imageUrl = s.image.url;
        }

        const prompt = args.join(' ');
        if (!prompt) {
          throw new Error("Please provide a prompt...!");
        }
       
        if (imageUrl) {
          apiReqUrl = Base + 'imagine';
          requestData = {
            prompt: imageUrl + ' ' + prompt,
            ...webhookOptions
          };
        } else {
          apiReqUrl = Base + 'imagine';
          requestData = {
            prompt: prompt,
            ...webhookOptions
          };
        }
       } 
     
      const name = event.senderID;
      const ID = event.messageID;
      const w = await message.reply("⛵ Initiating request to Midjourney.\n\n⏰ Please be patient...!");
      message.reaction('⏰', ID);
      const resultData = await processTask(apiReqUrl, requestData, message, w, apiKeyX, ID, name);

 if (resultData.data.status === "failed") {
         message.reply(`Request failed!\n\nReasons: ${resultData.data.task_result.error_messages}`);
        message.reaction('❌', ID);
        return;
      }
      let info;
      const { process_time: time, task_id: tid, task_result: { image_url: img }, task_result: { quota_used: quota } } = resultData.data;
      const count = resultData.count;
      if (resultData.data.meta.process_mode === "relax") {
        info = 'R:' + quota;
      } else {
        info = 'F:' + quota;
      }
     await message.reply({
        body: `Gen ID: ${count} \n\nGen Time: ${time} seconds\n\nStatus: ${info}\n\nAvailable Actions: U1,U2,U3,U4,V1,V2,V3,V4`,
        attachment: await getStreamFromURL(img),
      }, async (err, info) => {
        if (err) {
          console.error(err);
          message.reply(`Error: ${err.message}`);
          return;
        }

      message.reaction('✅', ID);
    global.GoatBot.onReply.set(info.messageID, {
          commandName: this.config.name,
          messageID: info.messageID,
          author: event.senderID,
          type: "reply",
          Y: tid,
          Z: img,
          X: count,
        });
      });
    } catch (error) {
      console.error(error);
      message.reply(`Error: ${error.message}`);
    }
  },

  onReply: async function ({ event, Reply, message }) {
    try {
      const { author, Y, X, Z, type } = Reply;
      const { senderID, body } = event;

      if (senderID != author) {
        return;
      }

      if (type == "reply") {
        const sides = ["U1", "U2", "U3", "U4"];
        const varModes = ["V1", "V2", "V3", "V4"];

        if (sides.includes(body)) {
          const pose = sidesIn(body);
          const upURL = API + `/upscale?side=${pose}&image_url=${Z}`;

          try {
            const w = await message.reply(`Processing Action\n\nID: ${X}`);
            const res = await axios.get(upURL);

            if (res.data.error) {
              throw new Error(`Error:\n${res.data.error}\nID: ${res.data.task_id}`);
            }

            const imgX = await short.shorten(res.data.image_url);

            message.reply({
              body: `Image Upscaled\n\nGen ID: ${X}\n\nDownload: ${imgX}`,
              attachment: await getStreamFromURL(imgX),
            }, (err, info) => {
              if (err) {
                console.error(err);
                message.reply(`Error: ${err.message || "Unknown error"}`);
                return;
              }

              global.GoatBot.onReply.set(info.messageID, {
                commandName: this.config.name,
                messageID: info.messageID,
                author: event.senderID,
                type: "upscale"
              });
            });

            await message.unsend(w.messageID);
          } catch (error) {
            console.error(error);
            message.reply(`Error: ${error.message || "Unknown error"}`);
          }
        } else if (varModes.includes(body)) {
     return message.reply("Variation disabled!");
          const pose = sidesIn(body);
          
          try {
           
            const w = await message.reply(`Processing Action\n\nID: ${X}`);
            const ID = event.messageID;
            const name = event.senderID;
      const resultData = await variationTask(Y, pose, w, ID, message, name);
      if (resultData.data.status === "failed") { 
      message.reply(`Request failed!\n\nReasons: ${resultData.data.task_result.error_messages}`);
    message.reaction('❌', ID);
                return;
              }
              let info;
              const { process_time: time, task_id: tid, task_result: { image_url: img }, task_result: { quota_used: quota } } = resultData.data;
              const count = resultData.count;
              if (resultData.data.meta.process_mode === "relax") {
                info = 'R:' + quota;
              } else {
                info = 'F:' + quota;
              }
             await message.reply({
                body: `Gen ID: ${count} \n\nGen Time: ${time} seconds\n\nStatus: ${info}\n\nAvailable Actions: U1,U2,U3,U4,V1,V2,V3,V4`,
                attachment: await getStreamFromURL(img),
            }, (err, info) => {
              if (err) {
                console.error(err);
                return  message.reply(`Error: ${err.message || "Unknown error"}`);
              }
    message.reaction('✅', ID);
              global.GoatBot.onReply.set(info.messageID, {
                commandName: this.config.name,
                messageID: info.messageID,
                author: event.senderID,
                type: "reply",
                Y: tid,
                Z: img,
                X: count
              });
            });
          } catch (error) {
            console.error(error);
            message.reply(`Error: ${error.message || "Unknown error"}`);
          }
        } else {
          message.reply("Invalid action.\n\nPlease choose from: U1, U2, U3, U4, V1, V2, V3, V4.");
        }
      } else if (type == "upscale") {
        const {  TID, count } = Reply;
        const upOPT = ["1", "2"];
        const zoom = ["3", "4"];

        if (upOPT.includes(body)) {
          const pose = sidesIn(body);
          const url = API +`/upscale?taskID=${TID}&side=${pose}`;

          try {
            const w = await message.reply(`Processing your request.\n\nGen ID: ${X}`);
            const res = await axios.get(url);

            if (res.data.error) {
              throw new Error(`Error:\n${res.data.error}\nID: ${res.data.task_id}`);
            }

            const { image_url: img, time_taken: time } = res.data;

            message.reply({
              body: `Image Upscaled (${pose})\n\nGen ID: ${X}\n\nTime taken: ${time} seconds`,
              attachment: await getStreamFromURL(img)
            });

            await message.unsend(w.messageID);
          } catch (error) {
            console.error(error);
            message.reply(`Error: ${error.message || "Unknown error"}`);
          }
        } else if (zoom.includes(body)) {
          const pose = sidesIn(body);
          const url = API +`/outpaint?taskID=${TID}&action=${pose}`;

          try {
            const w = await message.reply(`Processing your request.\n\nGen ID: ${count}`);
            const res = await axios.get(url);

            if (res.data.error) {
              throw new Error(`Error:\n${res.data.error}\nID: ${res.data.task_id}`);
            }

            count++;
            const { image_url: img, time_taken: time } = data;

            const countFilePath = path.join('requestCount.json');
            await fs.writeFile(countFilePath, JSON.stringify({ count }));

            message.reply({
              body: `Image Zoomed Out (${pose}x)\n\nGen ID: ${count}\n\nTime taken: ${time} seconds`,
              attachment: await getStreamFromURL(img)
            });

            await message.unsend(w.messageID);
          } catch (error) {
            console.error(error);
            message.reply(`Error: ${error.message || "Unknown error"}`);
          }
        } else {
          return;
        }
      }
    } catch (error) {
      console.error(error);
      message.reply(`Error: ${error.message || "Unknown error"}`);
    }
  }
};

function sidesIn(body) {
  switch (body) {
    case '1':
      return '2x';
    case '2':
      return '4x';
    case '3':
      return 1.5;
    case '4':
      return 2;
    case 'U1':
      return 1;
    case 'V1':
      return 1;
    case 'U2':
      return 2;
    case 'V2':
      return 2;
    case 'U3':
      return 3;
    case 'V3':
      return 3;
    case 'U4':
      return 4;
    case 'V4':
      return 4;
  }
}

async function fetchResultData(taskId, message, w, ID, name) {
  let Processing = false;
  let count = 1;
  while (true) {
    const res = await axios.post(`${Base}fetch`, { task_id: taskId }, {
      headers: {
        'Content-Type': 'application/json'
      }
    });

    if (res.data.status === "processing" && !Processing) {
      const countFilePath = path.join('requestCount.json');

      try {
        const countData = await fs.readFile(countFilePath, 'utf-8');
        count = JSON.parse(countData).count + 1;
      } catch (error) {}

      await fs.writeFile(countFilePath, JSON.stringify({ count }));
      message.reply(`Processing your request...\n\nRequest ID: ${count} `);
      message.reaction('⚙️', ID);
      await message.unsend(w.messageID);
      Processing = true;
    }

    if (res.data.status === "failed" || res.data.status === "finished") {
      await saveData(res.data, count, name);
      return {
        data: res.data,
        count: count
      };
    }
    await new Promise(resolve => setTimeout(resolve, 20000));
  }
}

async function processTask(apiReqUrl, requestData, message, w, apiKeyX, ID, name) {
  try {

    const response = await axios.post(apiReqUrl, requestData, {
      headers: {
        'X-API-KEY': apiKeyX,
        'Content-Type': 'application/json'
      }
    });

    if (response.data.status !== "success") {
      throw new Error(response.data);
    }

    const taskId = response.data.task_id;

    try {
      const resultData = await fetchResultData(taskId, message, w, ID, name);
      return resultData;
    } catch (resultError) {
      throw new Error(`Error fetching result data: ${resultError.message}`);
    }
  } catch (error) {
    if (error.response && error.response.status === 403) {
      currentApiKeyIndex = (currentApiKeyIndex + 1) % apiKeys.length;

      if (currentApiKeyIndex !== 0) {
   
        return await processTask(apiReqUrl, requestData, message, w, ID, apiKeys[currentApiKeyIndex], name);
      } else {
        throw new Error("Unable to process the request.");
      }
    } else if (error.response && error.response.status === 400) {
      await message.unsend(w.messageID);
      return { count: "N/A", data: { status: "failed", task_id: " N/A", task_result: { error_messages: "Invalid arguments in the prompt! Kindly rectify the issues and resend your request." } } };
    } else {
      throw error;
    }
  }
}

async function variationTask(message, w, ID, Y, pose, name) {
  try {
    const apiReqUrl = Base + "variation";
    const requestData = {
      origin_task_id: Y,
      index: pose,
      ...webhookOptions
    };
    
    const response = await axios.post(apiReqUrl, requestData, {
      headers: {
        'X-API-KEY': '50ceb33125551fb67ed017b4bf83418b5382448590fb84af73f7e5bc1a8e4eb6',
        'Content-Type': 'application/json'
      }
    });

    if (response.data.status !== "success") {
      throw new Error(response.data.message);
    }

    const taskId = response.data.task_id;

    try {
      const resultData = await fetchResultData(taskId, message, w, ID, name);
      return resultData;
    } catch (resultError) {
      throw new Error(`Error fetching result data: ${resultError.message}`);
    }
  } catch (error) {
    if (error.response && error.response.status === 403) {
        throw new Error("Unable to process the request.");
      
    } else if (error.response && error.response.status === 400) {

      return { count: "N/A", data: { status: "failed", task_id: "N/A", task_result: { error_messages: error.message } } };
    } else {
      throw error;
    }
  }
}
