const axios = require("axios");

module.exports = {
	config: {
		name: "dreamy",
		aliases: ["dream", "wow", "yeii"],
		version: "1.0",
		author: "JARiF@একটু পাত্তা দওনা চেটে চেটে খাব",
		countDown: 5,
		role: 0,
		shortDescription: {
			vi: "Tạo ảnh từ văn bản của bạn",
			en: "Create image from your text"
		},
		longDescription: {
			uid: "Tạo ảnh từ văn bản của bạn",
			en: "Create image from your text"
		},
		category: "Ai",
		guide: {
			vi: "   {pn} <prompt>: tạo ảnh từ văn bản của bạn"
				+ "\n    Ví dụ: {pn} mdjrny-v4 create a gta style house, gta, 4k, hyper detailed, cinematic, realistic, unreal engine, cinematic lighting, bright lights"
				+ "\n    Example: {pn} mdjrny-v4 create a gta style house, gta, 4k, hyper detailed, cinematic, realistic, unreal engine, cinematic lighting, bright lights"
		}
	},

	langs: {
		vi: {
			syntaxError: "⚠️ Vui lòng nhập prompt",
			error: "❗ Đã có lỗi xảy ra, vui lòng thử lại sau:\n%1",
			serverError: "❗ Server đang quá tải, vui lòng thử lại sau"
		},
		en: {
			syntaxError: "⚠️ Please enter prompt",
			error: "⏱ You are in the waiting time to use this command, please come back after 1.7s",
			serverError: "❗ Server is overloaded, please try again later"
		}
	},

	onStart: async function ({ message, args, getLang }) {
		const prompt = args.join("💚 Please wait for your imagination 🖤");
		if (!prompt)
			return message.reply(getLang("syntaxError"));

		try {
			const { data: imageStream } = await axios({
				url: "https://api.prodia.com/v1/job",
				method: "POST",
				headers: {
					"Content-Type": "application/json"
				},
				data: {
					prompt,
					styleId: 28,
					aspect_ratio: "16:9"
				},
				responseType: "stream"
			});

			imageStream.path = "image.jpg";

			return message.reply({
				attachment: imageStream
			});
		}
		catch (err) {
			return message.reply(getLang("error", err.response?.data?.message || err.message));
		}
	}
};