const fs = require('fs');
const axios = require('axios');
const path = require('path');

const model = [
"animagineXLV3_v30.safetensors [75f2f05b]"
];

module.exports = {
  config: {
    name: 'anix',
    version: '1.0',
    author: 'JARiF@একটু পাত্তা দওনা চেটে চেটে খাব',
    countDown: 5,
    role: 0,
    category: 'odof',
    guide: {
      vi: '',
      en: "1. DreamshaperXL10\n2. DynavisionXL\n3. JuggernautXL\n4. RealismEngineSDXL\n5. Sdxl 1.0\n6. Turbo vision XL", 
    },
  },

  onStart: async function ({ event, api, args, message }) {
      const [prompt, modelNumber] = args.slice(1).join(' ').split('|').map((str) => str.trim());

    // Change the selectedModelIndex to 5 for the fifth model (Sdxl 1.0)
    const selectedModelIndex = 7;
    const selectedModel = model[selectedModelIndex - 1] || model[0];

    message.reply('✅ | Please wait...', async (err, info) => {
      if (err) {
        console.error(err);
        return;
      }

      const api_key = '3d0a1d4c-5251-4643-b094-6c1220745968';

      async function generateImage(prompt, selectedModel) {
        try {
          const options = {
            method: 'POST',
            url: 'https://api.prodia.com/v1/sdxl/generate',
            headers: {
              accept: 'application/json',
              'content-type': 'application/json',
              'X-Prodia-Key': api_key,
            },
            data: {
              prompt: prompt,
              model: selectedModel, 
              negative_prompt: 'lowres, bad anatomy, bad hands, text, error, missing fingers, extra digit, fewer digits, cropped, worst quality, low quality, normal quality, jpeg artifacts, signature, watermark, username, blurry, artist name',
              steps: 50,
              cfg_scale: 7,
              seed: -1,
              upscale: true,
              sampler: 'Euler a',
              width: 896,
  height: 1152
            },
          };

          const response = await axios(options);
          const job = response.data.job;

          while (true) {
            const jobResponse = await axios.get(
              `https://api.prodia.com/v1/job/${job}`,
              {
                headers: {
                  accept: 'application/json',
                  'X-Prodia-Key': api_key,
                },
              }
            );

            if (jobResponse.data.status === 'succeeded') {
              const imageUrl = jobResponse.data.imageUrl;
              const imageResponse = await axios.get(imageUrl, {
                responseType: 'arraybuffer',
              });
              return imageResponse.data;
            }

            await new Promise((resolve) => setTimeout(resolve, 500));
          }
        } catch (err) {
          console.error(err);
          throw err;
        }
      }

      try {
        const imageBuffer = await generateImage(prompt, selectedModel);
        const imageFileName = '1.png';
        const imagePath = path.join(__dirname, imageFileName);
        fs.writeFileSync(imagePath, imageBuffer);

        await message.reply(
          {
            body: '✅ | Image generated.', 
            attachment: fs.createReadStream(imagePath),
          },
          event.threadID
        );
      } catch (error) {
        console.error(error);
      }
    });
  },
};