const styles = [ "sai-base", "cinematic-default", "sai-3d-model", "sai-analog film", "sai-anime", "sai-cinematic", "sai-comic book", "sai-craft clay", "sai-digital art", "sai-enhance", "sai-fantasy art", "sai-isometric", "sai-line art", "sai-lowpoly", "sai-neonpunk", "sai-origami", "sai-photographic", "sai-pixel art", "sai-texture", "ads-advertising", "ads-automotive", "ads-corporate", "ads-fashion editorial", "ads-food photography", "ads-luxury", "ads-real estate", "ads-retail", "artstyle-abstract", "artstyle-abstract expressionism", "artstyle-art deco", "artstyle-art nouveau", "artstyle-constructivist", "artstyle-cubist", "artstyle-expressionist", "artstyle-graffiti", "artstyle-hyperrealism", "artstyle-impressionist", "artstyle-pointillism", "artstyle-pop art", "artstyle-psychedelic", "artstyle-renaissance", "artstyle-steampunk", "artstyle-surrealist", "artstyle-typography", "artstyle-watercolor", "futuristic-biomechanical", "futuristic-biomechanical cyberpunk", "futuristic-cybernetic", "futuristic-cybernetic robot", "futuristic-cyberpunk cityscape", "futuristic-futuristic", "futuristic-retro cyberpunk", "futuristic-retro futurism", "futuristic-sci-fi", "futuristic-vaporwave", "game-bubble bobble", "game-cyberpunk game", "game-fighting game", "game-gta", "game-mario", "game-minecraft", "game-pokemon", "game-retro arcade", "game-retro game", "game-rpg fantasy game", "game-strategy game", "game-streetfighter", "game-zelda", "misc-architectural", "misc-disco", "misc-dreamscape", "misc-dystopian", "misc-fairy tale", "misc-gothic", "misc-grunge", "misc-horror", "misc-kawaii", "misc-lovecraftian", "misc-macabre", "misc-manga", "misc-metropolis", "misc-minimalist", "misc-monochrome", "misc-nautical", "misc-space", "misc-stained glass", "misc-techwear fashion", "misc-tribal", "misc-zentangle", "papercraft-collage", "papercraft-flat papercut", "papercraft-kirigami", "papercraft-paper mache", "papercraft-paper quilling", "papercraft-papercut collage", "papercraft-papercut shadow box", "papercraft-stacked papercut", "papercraft-thick layered papercut", "photo-alien", "photo-film noir", "photo-hdr", "photo-long exposure", "photo-neon noir", "photo-silhouette", "photo-tilt-shift"];


module.exports = {
  config: {
    name: "artistry",
    version: "1.0",
    author: "JARiF@একটু পাত্তা দওনা চেটে চেটে খাব",
    countDown: 10,
    role: 0,
    shortDescription: {
      en: 'Text to Image'
    },
    longDescription: {
      en: "Text to image"
    },
    category: "image",
    guide: {
      en: `1: BASE
2: CINEMATIC
3: 3D-MODEL
4: ANALOG FILM
5: ANIME
6: CINEMATIC
7: COMIC BOOK
8: CRAFT CLAY
9: DIGITAL ART
10: ENHANCE
11: FANTASY ART
12: ISOMETRIC
13: LINE ART
14: LOWPOLY
15: NEONPUNK
16: ORIGAMI
17: PHOTOGRAPHIC
18: PIXEL ART
19: TEXTURE
20: ADVERTISING
21: AUTOMOTIVE
22: CORPORATE
23: FASHION EDITORIAL
24: FOOD PHOTOGRAPHY
25: LUXURY
26: REAL ESTATE
27: RETAIL
28: ABSTRACT
29: ABSTRACT EXPRESSIONISM
30: ART DECO
31: ART NOUVEAU
32: CONSTRUCTIVIST
33: CUBIST
34: EXPRESSIONIST
35: GRAFFITI
36: HYPERREALISM
37: IMPRESSIONIST
38: POINTILLISM
39: POP ART
40: PSYCHEDELIC
41: RENAISSANCE
42: STEAMPUNK
43: SURREALIST
44: TYPOGRAPHY
45: WATERCOLOR
46: BIOMECHANICAL
47: BIOMECHANICAL CYBERPUNK
48: CYBERNETIC
49: CYBERNETIC ROBOT
50: CYBERPUNK CITYSCAPE
51: FUTURISTIC
52: RETRO CYBERPUNK
53: RETRO FUTURISM
54: SCI-FI
55: VAPORWAVE
56: BUBBLE BOBBLE
57: CYBERPUNK GAME
58: FIGHTING GAME
59: GTA
60: MARIO
61: MINECRAFT
62: POKEMON
63: RETRO ARCADE
64: RETRO GAME
65: RPG FANTASY GAME
66: STRATEGY GAME
67: STREETFIGHTER
68: ZELDA
69: ARCHITECTURAL
70: DISCO
71: DREAMSCAPE
72: DYSTOPIAN
73: FAIRY TALE
74: GOTHIC
75: GRUNGE
76: HORROR
77: KAWAII
78: LOVECRAFTIAN
79: MACABRE
80: MANGA
81: METROPOLIS
82: MINIMALIST
83: MONOCHROME
84: NAUTICAL
85: SPACE
86: STAINED GLASS
87: TECHWEAR FASHION
88: TRIBAL
89: ZENTANGLE
90: COLLAGE
91: FLAT PAPERCUT
92: KIRIGAMI
93: PAPER MACHE
94: PAPER QUILLING
95: PAPERCUT COLLAGE
96: PAPERCUT SHADOW BOX
97: STACKED PAPERCUT
98: THICK LAYERED PAPERCUT
99:  ALIEN
100: FILM NOIR
101: HDR
102: LONG EXPOSURE
103: NEON NOIR
104: SILHOUETTE
105: TILT-SHIFT`,
    }
  },

  onStart: async function ({ message, args }) {
    const text = args.join(" ");
    if (!text) {
      return message.reply("Please provide a prompt.");
    }

    let prompt, selectedStyle;
    if (text.includes("|")) {
      const [promptText, styleInput] = text.split("|").map((str) => str.trim());
      prompt = promptText;

      if (!isNaN(styleInput)) {
        const styleNumber = parseInt(styleInput);
        if (styleNumber >= 1 && styleNumber <= styles.length) {
          selectedStyle = styles[styleNumber - 1];
        } else {
          return message.reply("Invalid style number. Please use a valid number from the guide.");
        }
      } else {
        return message.reply("Invalid style input. Please use a valid style number from the guide.");
      }
    } else {
      prompt = text;
      selectedStyle = "cinematic-default";
    }

    const waitingMessage = await message.reply('Please wait...');

    try {
      const API = `https://api.annie-jarif.repl.co/annie?prompt=${encodeURIComponent(prompt)}&styles=${selectedStyle}`;

      const imageStream = await global.utils.getStreamFromURL(API);

      await message.reply({
        attachment: imageStream,
      });
    } catch (error) {
      message.reply(error.message).then(() => {
       message.unsend(waitingMessage);
      });
    }
  },
};