const axios = require('axios');
const fs = require('fs-extra');
const path = require('path');

module.exports = {
  config: {
    name: "illusion",
    version: "1.0",
    author: "Jarid",
    category: "wd",
    countDown: 50
  },

  onStart: async function ({ api, event, args, message }) {
    const text = args.join(' ');

 if (event.type === "message_reply" && event.messageReply.attachments[0]?.type === "photo") {
      const imageUrl = event.messageReply.attachments[0].url;
   const waitingMessage = message.reply("✅ | Transforming your image...");
  //  const waitingMessage = await api.sendMessage("Generating video, please wait...", event.threadID);
    const url = 'https://54285744-illusion-diffusion.gateway.alpha.fal.ai/';
    const dataToSend = {
  image_url: imageUrl,
  prompt: text,
  negative_prompt: "(worst quality, poor details:1.4), lowres, (artist name, signature, watermark:1.4), bad-artist-anime, bad_prompt_version2, bad-hands-5, ng_deepnegative_v1_75t",
  guidance_scale: 7.5,
  controlnet_conditioning_scale: 1.7,
  control_guidance_start: 0,
  control_guidance_end: 1,
  control_guidance_scale: 1,
  scheduler: "Euler",
  num_inference_steps: 40,
  image_size: "square_hd"
    };

    const headers = {
      Authorization: 'Key 11c6a1e5-b67f-459a-aed8-67ddc0571229:004342e74776cc16628e96b04bd4b5b8',
      'Content-Type': 'application/json',
    };

    try {
      const response = await axios.post(url, dataToSend, { headers });
      const data = response.data;

      const videoUrl = data.image.url;
      const content_type = data.image.content_type;
      const file_name = data.image.file_name;

      const videoResponse = await axios.get(videoUrl, { responseType: 'stream' });
      const videoStream = videoResponse.data;

      const filePath = path.join(__dirname, file_name); 
      const videoFile = fs.createWriteStream(filePath);

      videoStream.pipe(videoFile);

      videoFile.on('finish', async () => {
        console.log("Video file saved successfully.");

        const result = await message.reply(
          { attachment: fs.createReadStream(filePath) },
          event.threadID
        );

        fs.unlinkSync(filePath);
        console.log("Video file sent successfully.");
      });
    } catch (error) {
      console.error("Error sending video:", error);}
} else {
      await message.reply("⚠️ | Reply to an image.");
    }
  }
};