const axios = require("axios");
const ratios = ["square_hd", "square", "portrait_4_3", "portrait_16_9", "landscape_4_3", "landscape_16_9"];

module.exports = {
    config: {
        name: "aniart",
        version: "1.0",
        author: "JARiF@Cock",
        countDown: 5,
        role: 0,
        category: "box chat",
        guide: {
            en: "{pn} [prompt] | ratio number\nExample: {pn} cat | 2\n\nAvailable Ratio's:\n1. SQUARE HD\n2. SQUARE\n3. PORTRAIT 4:3\n4. PORTRAIT 9:16\n5. LANDSCAPE 4:3\n6. LANDSCAPE 16:9"
        }
    },
    onStart: async function ({ message, event, args, api }) {
        let imageUrl;

        if (event.type === "message_reply") {
            const replyAttachment = event.messageReply.attachments[0];
            if (["photo", "sticker"].includes(replyAttachment?.type)) {
                imageUrl = replyAttachment.url;
            } else {
                return api.sendMessage(
                    { body: "❌ | Reply must be an image." },
                    event.threadID
                );
            }
        } else if (args[0]?.match(/(https?:\/\/.*\.(?:png|jpg|jpeg))/g)) {
            imageUrl = args[0];
        } else {
            return api.sendMessage({ body: "❌ | Reply to an image." }, event.threadID);
        }

        const [text, ratioNumber] = args.join(' ').split(' | ');
        const ratioIndex = parseInt(ratioNumber) - 1 || "square_hd";
        const randomSeed = Math.floor(Math.random() * 1000000);
        const waitingMessage = await message.reply('✅ | Please wait...');

        const data = {
            model_name: "cagliostrolab/animagine-xl-3.0",
            model_architecture: "sdxl",
            prompt: text || "Anime style",
            negative_prompt: "lowres, bad anatomy, bad hands, text, error, missing fingers, extra digit, fewer digits, cropped, worst quality, low quality, normal quality, jpeg artifacts, signature, watermark, username, blurry, artist name",
            image_url: imageUrl,
            loras: [
                {
                    "path": "https://huggingface.co/Linaqruf/anime-detailer-xl-lora/resolve/main/anime-detailer-xl.safetensors",
                    "scale": 1
                }
            ],
            num_inference_steps: 40,
            guidance_scale: 7.5,
            strength: 0.5,
            image_size: ratios[ratioIndex] || "square_hd",
            scheduler: "Euler A",
            num_images: 1,
            image_format: "jpeg",
            seed: randomSeed
        };

        const config = {
            headers: {
                'Authorization': 'Key 5bfe0d58-4a09-4a8c-8bf4-fb49954c3a85:8afb2e7e5213c0903fae0bbc6790945b',
                'Content-Type': 'application/json'
            }
        };

        try {
            const response = await axios.post('https://fal.run/fal-ai/image-to-image', data, config);
            const r = response.data.images[0].url;
            await message.reply({
                body: `✅ | Image Generated\nYour Prompt: ${text}`,
                attachment: await global.utils.getStreamFromURL(r),
            });
            await api.unsendMessage(waitingMessage.messageID);
        } catch (error) {
            console.error(error);
        }
    }
};