const axios = require('axios');
const fs = require('fs-extra');
const path = require('path');

module.exports = {
  config: {
    name: 'lcm',
    version: '1.0',
    author: 'JARiF@একটু পাত্তা দওনা চেটে চেটে খাব',
    countDown: 0,
    category: 'wd',
    guide: {
        en: "{pn} [prompt]",
      },
  },

  onStart: async function ({ api, event, args, message }) {
    const text = args.join(' ');

    if (!text) {
      message.reply('Please provide a prompt.');
      return;
    }

  const randomSeed = Math.floor(Math.random() * 1000000);

    const waitingMessage = await api.sendMessage('Please wait...', event.threadID);

    const url = 'https://110602490-lora.gateway.alpha.fal.ai';
    const dataToSend = {
      model_name: 'nyxia/AAM-AnyLoRA-Anime-Mix',
      prompt: text,
      negative_prompt: '',
      loras: [
        {
          path: 'https://huggingface.co/latent-consistency/lcm-lora-sdv1-5/resolve/main/pytorch_lora_weights.safetensors?download=true',
          scale: 1
        }
      ],
      seed: randomSeed,
      image_size: 'square',
      num_inference_steps: 12,
      guidance_scale: 2,
      clip_skip: 2,
      model_architecture: 'sd',
      scheduler: 'Euler A',
      image_format: 'jpeg',
      num_images: 1
    };

    const headers = {
      Authorization: 'Key 5bfe0d58-4a09-4a8c-8bf4-fb49954c3a85:8afb2e7e5213c0903fae0bbc6790945b',
      'Content-Type': 'application/json',
    };

    try {
          const response = await axios.post(url, dataToSend, { headers });

          const audioUrl = response.data.images[0].url;
          const audioFileName = 'audio.jpg';
          const audioFilePath = path.join(__dirname, audioFileName);

          const audioResponse = await axios.get(audioUrl, { responseType: 'stream' });
          const audioFile = fs.createWriteStream(audioFilePath);

          audioResponse.data.pipe(audioFile);

          audioFile.on('finish', () => {
            audioFile.close();

            const audioOutputPath = path.join(__dirname, 'jarif.jpg');
            fs.rename(audioFilePath, audioOutputPath, (err) => {
              if (err) {
                message.reply('❌ | Error renaming the file.');
              } else {
                message.reply({ body: '', attachment: fs.createReadStream(audioOutputPath) });
              }
            });
          });
        } catch (error) {
          message.reply('❌ | ' + error.message);
        }
      },
    };