const axios = require("axios");
const { getStreamFromURL, shortenURL } = global.utils;
const maxTokens = 100;
const maxStorageMessage = 4;

if (!global.temp.conversation)
 global.temp.conversation = {};

if (!global.temp.conversationHistroy)
 global.temp.conversationHistroy = {};

const { conversation, conversationHistroy } = global.temp;

module.exports = {
 config: {
 name: "gpt4",
 version: "1.3",
 author: "Akash",
 countDown: 0,
 role: 0,
 shortDescription: {
 en: "b"
  },
 longDescription: {
 en: "b"
 },
 category: "AI",
 guide: {
 en: "{pn}"
  }
 },
 langs: {
 en: {
 error: "An error has occurred:\n%1",
 clearHistory: "Data Cleared Successfully."
  }
 },
 onStart: async function ({ message, event, args, getLang, prefix, commandName }) {
 switch (args[0]) {
 case 'clear':
 conversationHistroy[event.senderID] = [];
 return message.reply(getLang('clearHistory'));

 default:
 await handleBard(event, message, args, getLang, commandName);
 break;
  }
 },
 onReply: async function ({ Reply, message, event, args, getLang, commandName }) {
  const { senderID, body } = event;
  const Word = body && body.split(' ')[0];
  const { author } = Reply;

  if (author !== senderID) {
    return;
  }

  if (Word.toLowerCase() === 'clear') {
    conversationHistroy[event.senderID] = [];
    return message.reply(getLang('clearHistory'));
  } else {
    await handleBard(event, message, args, getLang, commandName);
  }
 }
};


async function askBard(event) {
  let url;
  if (event.type === "message_reply" && event.messageReply.attachments && event.messageReply.attachments.length > 0) {
    const attachment = event.messageReply.attachments[0];

    if (attachment.type === "photo" && attachment.url) {
      const fullurl = attachment.url;
      url = await shortenURL(fullurl);
    }
  }

  const systemMessage = {
    role: 'system',
    content: 'you are helpful AI assistant. reply in short yet precise response that is easy to understand.'
  };

  const messages = [systemMessage, ...conversationHistroy[event.senderID].map(entry => ({ role: entry.role, content: entry.content }))];

  const requestBody = {
    mode: "gpt-4-turbo",
    messages: messages
  };

  const response = await fetch("https://api.monolyth.ai/v1/chat/completions", {
    method: "POST",
    headers: {
      "Content-Type": "application/json",
      "Authorization": "Bearer sk-monolyth-v1-929f54d4cb626ef14143199f27ce96575b1f6dcbe27bdcdc3b86569b5eb35521"
    },
    body: JSON.stringify(requestBody)
  });

  const data = await response.json();
  const text = data.choices[0].message.content;

  return {
    message: text,
    imageUrlsX: []
  };
}



async function handleBard(event, message, args, getLang, commandName) {
  try {
    conversation[event.senderID] = true;

    if (!conversationHistroy[event.senderID] || !Array.isArray(conversationHistroy[event.senderID]))
      conversationHistroy[event.senderID] = [];

    if (conversationHistroy[event.senderID].length >= maxStorageMessage)
      conversationHistroy[event.senderID].shift();

    conversationHistroy[event.senderID].push({
      role: 'user',
      content: args.join(' ')
    });

    const response = await askBard(event);
    const text = response.message;
    const imageUrls = response.imageUrlsX;

    conversationHistroy[event.senderID].push({
      role: `assistant`,
      content: text
    });

    return message.reply({
      body: text,
      attachment: imageUrls
    }, (err, info) => {
      global.GoatBot.onReply.set(info.messageID, {
        commandName,
        author: event.senderID,
        messageID: info.messageID
      });
    });
  } catch (err) {
    const errorMessage = err.response?.data.error.message || err.message || "";
    return message.reply(getLang('error', errorMessage));
  } finally {
    delete conversation[event.senderID];
  }
}