const axios = require('axios');
const tracker = {};

module.exports = {
  config: {
    name: "gpt4o",
    version: "1.0",
    author: "rehat--",
    countDown: 5,
    role: 0,
    longDescription: "Chat with gpt4o most advanced artificial intelligence.",
    category: "ai",
    guide: { en: "{pn} <query>" },
  },
  clearHistory: function () {
    global.GoatBot.onReply.clear();
  },
  onStart: async function ({ message, event, args, usersData, commandName }) {
    const prompt = args.join(' ');
    const userName = await usersData.getName(event.senderID);
    const userID = event.senderID;

    if (!args[0]) return message.reply('Please enter a query.');
    
    if (args[0] === 'clear') {
      this.clearHistory();
      const c = await clean(userID);
      if (c) return message.reply('Conversation history cleared.');
    }

    const imageUrl = event.messageReply?.attachments?.[0]?.url;
    await elysia(prompt, userID, message, userName, imageUrl);
  },
  onReply: async function ({ Reply, message, event, args, getLang, usersData }) {
    const { author } = Reply;
    if (author !== event.senderID) return;
    const prompt = args.join(' ');
    const userID = event.senderID;
    const userName = await usersData.getName(event.senderID);
    await elysia(prompt, userID, message, userName);
  }
};

async function clean(userID) {
  if (tracker[userID]) {
    delete tracker[userID];
    return true;
  }
  return false;
}

async function elysia(text, userID, message, userName, attachment = null) {
  if (!tracker[userID]) {
    tracker[userID] = `${userName}.\n`;
  }
  tracker[userID] += `${text}.\n`;

  try {
    const query = encodeURIComponent(`- Current prompt: ${text}\n\n - Conversation:\n${tracker[userID]}\n`);
    let url = `https://rehatdesu.xyz/api/llm/gpt4o?query=${query}&apikey=gpt4o`;

    if (attachment) {
      url += `&attachment=${encodeURIComponent(attachment)}`;
    }

    const response = await axios.post(url, {
      headers: {
        'Content-Type': 'application/json',
      },
    });

    const resultText = response.data.response;
    tracker[userID] += `${resultText}\n`;
    await message.reply(resultText, (error, info) => {
      if (!error) {
        global.GoatBot.onReply.set(info.messageID, {
          commandName: 'gpt4o',
          author: userID
        });
      }
    });
  } catch (error) {
    message.reply("An error occurred.");
  }
}
