const axios = require('axios');


module.exports = {
  config: {
    name: "gta",
    version: "1.0",
    author: "Jiraf",
    shortDescription: {
      en: "Short description"
    },
    longDescription: {
      en: "Long description"
    },
    category: "Memes",
    countDown: 5,
    role: 0,
    guide: {
      en: "{pn} <prompt>"
    }
  },

  onStart: async function ({ api, event, args, message, bot }) {
    const apiUrl = 'https://api.scrolller.com/api/v2/graphql';
const headers = {
  'cache-control': 'no-cache',
  'origin': 'https://scrolller.com',
  'referer': 'https://scrolller.com/',
  'user-agent': 'Mozilla/5.0 (Linux; Android 10; K) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/120.0.0.0 Mobile Safari/537.36',
  'Content-Type': 'application/json',
};

const query = `
  query SubredditQuery($url: String!, $filter: SubredditPostFilter, $iterator: String) {
    getSubreddit(url: $url) {
      children(limit: 50, iterator: $iterator, filter: $filter, disabledHosts: null) {
        iterator
        items {
          mediaSources {
            url
            width
            height
            isOptimized
          }
        }
      }
    }
  }
`;

const variables = {
  url: '/r/GTA',
  filter: 'VIDEO',
};

axios.post(apiUrl, {
  query: query,
  variables: variables,
}, {
  headers: headers,
})
  .then(response => {
    const items = response.data.data.getSubreddit.children.items;
    const mp4Urls = items.flatMap(item => item.mediaSources.map(source => source.url)).filter(url => url.endsWith('.mp4'));
    const randomUrl = mp4Urls[Math.floor(Math.random() * mp4Urls.length)];
    message.chuden(randomUrl);
  })
  .catch(error => {
   message.reply(error);
  });
}
}