const axios = require('axios');

const styles = [
  "anime",
  "enhance",
  "digital-art",
  "photographic",
  "comic-book",
  "analog-film",
  "fantasy-art",
  "neonpunk",
  "analog-film",
  "isometric",
  "lowpoly",
  "photorealistic",
  "futuristic",
  "pixel-art",
  "cinematic",
  "line-art",
  "origami",
  "realism",
  "3d-model",
  "texture",
  "futuristic",
  "craft-clay"
];

module.exports = {
  config: {
    name: "kamla",
    version: "1.0",
    author: "JARiF@একটু পাত্তা দওনা চেটে চেটে খাব",
    countDown: 10,
    role: 0,
    shortDescription: {
      en: 'Text to Image'
    },
    longDescription: {
      en: "Text to image"
    },
    category: "image",
    guide: {
      en: styles.map((item, index) => `${index + 1}. ${item}`).join('\n'),
    }
  },

  onStart: async function ({ message, args }) {
    const text = args.join(" ");
    if (!text) {
      return message.reply("Please provide a prompt.");
    }

    let prompt, styles;
    if (text.includes("|")) {
      const [promptText, stylesText] = text.split("|").map((str) => str.trim());
      prompt = promptText;
      styles = stylesText;
    } else {
      prompt = text;
      styles = "1";  
    }

    let id;

    const waitingMessage = message.reply('Please wait.');

    try {
      const API = `https://www.api.vyturex.com/kitty?prompt=${encodeURIComponent(prompt)}&style=${styles}`;
      const imageStream = await global.utils.getStreamFromURL(API);

      await message.reply({
        attachment: imageStream
      });
    } catch (error) {
      message.reply(error.message).then(() => {
        message.unsend(id);
      });
    }
  }
};