const axios = require('axios');
const tinyurl = require('tinyurl'); 

module.exports = {
  config: {
    name: 'Lyrics',
    version: '1.0.5',
    author: 'Eijah Noah',
    description: 'Get song lyrics.',
    category: 'Music',
    usages: '/Lyrics [song name]',
    countDown: 5,
  },

  onStart: async function ({ event, args, message }) {
    try {
      let query;
      let b = 'com';

      if (event.type === "message_reply" && ["audio", "video"].includes(event.messageReply.attachments[0].type)) {
        const attachmentUrl = event.messageReply.attachments[0].url;
        const shortUrl = await tinyurl.shorten(attachmentUrl);
        const response = await axios.get(`https://www.api.vyturex.${b}/songr?url=${shortUrl}`);

        if (response.data && response.data.title) {
          query = response.data.title;
        } 
      } else {
        query = args.join(" "); 
        const apis = await axios.get(`https://api.vyturex.${b}/lyrics?query=${query}`);

        const lyrics = apis.data.lyrics;
        const title = apis.data.title;
        const artist = apis.data.artist;
        const img = apis.data.image;
        message.reply({
          body: `Lyrics: ${lyrics}\n\nSong Name: ${title}\n\nWriter: ${artist}`,
          attachment: await global.utils.getStreamFromURL(img),
        });
        return;
      } 

      const apis = await axios.get(`https://api.vyturex.${b}/lyrics?query=${query}`);
      const lyrics = apis.data.lyrics;
      const title = apis.data.title;
      const artist = apis.data.artist;
      const img = apis.data.image;
      message.reply({
        body: `Lyrics: ${lyrics}\n\nSong Name: ${title}\n\nWriter: ${artist}`,
        attachment: await global.utils.getStreamFromURL(img),
      });
    } catch (error) {
      console.error(error); 
      message.reply("❌ | Lyrics not available!");
    }
  }
};