const { getStreamFromURL, uploadImgbb } = global.utils;
const axios = require("axios");

const API = "https://api.ohmygpt.com/api/v1/ai/draw/mj";
const WBH = "https://discord.com/api/webhooks/1188193667656187966/axKr6-bD9r7UFicSjLR-Jzm2GPgQV5TlmA9H0or76EAox2zSgCbENSmonb2lURmB55WM";
const key = 'sk-QeZAIJSFdB213bAD1CEdT3BLbkFJ9e853150bCE14383b862';

module.exports = {
  config: {
    name: "mj",
    version: "1.0",
    author: "Akash",
    countDown: 40,
    role: 0,
    longDescription: "Interact with the Midjourney for various image processing tasks.",
    category: "Ai Imagination",
    guide: { en: "{pn} prompt" },
  },

  onStart: async function ({ api, args, event, message }) {
    try {
      const permission = ["100082247235177", "100032778441480", "100077553281922", "100066407270658", "100080352260736", "100070029543010", "100017822257155", "100087595555128", "100075513816623"];

      if (!permission.includes(event.senderID)) {
        api.sendMessage("~OhBaka!Seems you don't have permission to use this cmd! 🐕‍🦺", event.threadID, event.messageID);
        return;
      }

      let url;
      let data;

      if (args[0] === "stat") {
        const taskID = args[1];
        if (!taskID) {
          return message.reply("Please provide a task ID to proceed.");
        }
        const s = await axios.post(API + "/query", {
          model: 'midjourney',
          taskId: taskID.toString()
        }, {
          headers: {
            'User-Agent': 'Apifox/1.0.0 (https://apifox.com)',
            'Authorization': `Bearer ${key}`
          }
        });
        let reply;

        if (s.data.data.imageDcUrl && s.data.data.imageDcUrl.length > 0) {
          reply = {
            body: `Status of ${s.data.data.taskId}:\nStatus: ${s.data.data.status}\nProgress: ${s.data.data.progress}\nPrompt: ${s.data.data.prompt}`,
            attachment: await getStreamFromURL(s.data.data.imageDcUrl)
          };
        } else {
          reply = {
            body: `Status of ${s.data.data.taskId}:\nStatus: ${s.data.data.status}\nProgress: ${s.data.data.progress}\nPrompt: ${s.data.data.prompt}`
          };
        }

        return message.reply(reply);
      } else if (args[0] === "describe") {
        let imageUrl = null;

        if (event.type === "message_reply" && ["photo", "sticker"].includes(event.messageReply.attachments?.[0]?.type)) {
          const s = await uploadImgbb(event.messageReply.attachments[0].url);
          imageUrl = s.image.url;
        }
        if (!imageUrl) {
          return message.reply("Invalid request. Reply to an image to proceed.");
        }
        const dataUrl = await convert(imageUrl);
        url = API + '/describe';
        data = {
          model: 'midjourney',
          base64: dataUrl,
          type: 'NORMAL',
          webhook: WBH
        };
      } else {
        let imageUrl = null;

        if (event.type === "message_reply" && ["photo", "sticker"].includes(event.messageReply.attachments?.[0]?.type)) {
          const s = await uploadImgbb(event.messageReply.attachments[0].url);
          imageUrl = s.image.url;
        }

        const prompt = args.join(' ');
        if (!prompt) {
          throw new Error("Please provide a prompt...");
        }

        if (imageUrl) {
          url = API + '/imagine';
          data = {
            model: 'midjourney',
            prompt: imageUrl + ' ' + prompt,
            type: 'NORMAL',
            webhook: WBH
          };
        } else {
          url = API + '/imagine';
          data = {
            model: 'midjourney',
            prompt: prompt,
            type: 'NORMAL',
            webhook: WBH
          };
        }
      }

      const ID = event.messageID;
      const resultData = await process(url, data, message, ID);

      if (resultData.data.status !== "SUCCESS") {
        message.reaction('❌', ID);
        throw new Error(resultData.data.failReason);
      }
      const { taskId: id, imageDcUrl: img } = resultData.data;

      if (resultData.data.action === "DESCRIBE") {
        await message.reply({
          body: `TaskID: ${id}\n\n${resultData.data.prompt}`,
          attachment: await getStreamFromURL(img),
        }, async (err, info) => {
          if (err) {
            console.error(err);
            message.reply(`Error: ${err.message}`);
            return;
          }

          message.reaction('✅', event.messageID);
          global.GoatBot.onReply.set(info.messageID, {
            commandName: this.config.name,
            messageID: info.messageID,
            author: event.senderID,
            type: "describe",
            prompts: resultData.data.prompt
          });
        });
      } else {
        const actions = resultData.data.actions;

        const labelEmojiCId = actions.map(action => ({
          label: action.label,
          emoji: action.emoji,
          customId: action.customId
        }));

        const buttons = labelEmojiCId.map(item => item.label !== '' ? item.label : item.emoji);

        await message.reply({
          body: `TaskID: ${id}\nAvailable Actions: ${buttons.join(',')}\n\nLink: ${img}`,
          attachment: await getStreamFromURL(img),
        }, async (err, info) => {
          if (err) {
            console.error(err);
            message.reply(`Error: ${err.message}`);
            return;
          }

          message.reaction('✅', event.messageID);
          global.GoatBot.onReply.set(info.messageID, {
            commandName: this.config.name,
            messageID: info.messageID,
            author: event.senderID,
            type: "reply",
            taskId: id,
            buttons: buttons,
            akash: labelEmojiCId
          });
        });
      }
    } catch (error) {
      console.error(error);
      message.reply(`Error: ${error.message}`);
    }
  },

  onReply: async function ({ event, Reply, message }) {
    try {
      const { author, taskId, buttons, akash, type, prompts } = Reply;
      const { senderID, body } = event;

      if (senderID != author) {
        return;
      }
      let button = buttons;
      const taskID = taskId;
      const Ids = akash;

      if (type == "reply") {
        if (!button.some(btn => body.includes(btn))) {
          return message.reply("Invalid Action!\n\nAvailable Actions: " + button.join(','));
        }
        const customId = getCustomId(body, Ids);
        const data = new URLSearchParams();
        data.append('model', 'midjourney');
        data.append('taskId', `${taskID}`);
        data.append('customId', `${customId}`);
        data.append('type', 'NORMAL');
        data.append('webhook', WBH);
        data.append('base64Mask', '');
        const ID = event.messageID;
        const resultData = await process(API + "/action", data, message, ID);

        const { taskId: id, imageDcUrl: img } = resultData.data;
        const actions = resultData.data.actions;

        const labelEmojiCId = actions.map(action => ({
          label: action.label,
          emoji: action.emoji,
          customId: action.customId
        }));

        const buttons = labelEmojiCId.map(item => item.label !== '' ? item.label : item.emoji);

        if (resultData.data.status !== "SUCCESS") {
          throw new Error(resultData.data.failReason);
        }

        await message.reply({
          body: `TaskID: ${id}\nAvailable Actions: ${buttons.join(',')}\n\nLink: ${img}`,
          attachment: await getStreamFromURL(img),
        }, async (err, info) => {
          if (err) {
            console.error(err);
            message.reply(`Error: ${err.message}`);
            return;
          }

          message.reaction('✅', event.messageID);
          global.GoatBot.onReply.set(info.messageID, {
            commandName: this.config.name,
            messageID: info.messageID,
            author: event.senderID,
            type: "mod",
            taskId: id,
            buttons: buttons,
            akash: labelEmojiCId
          });
        });
      } else if (type === "mod") {

        if (!button.some(btn => body.includes(btn))) {
          return message.reply("Invalid Action!\n\nAvailable Actions: " + button.join(','));
        }

        const customId = getCustomId(body, Ids);

        const data = new URLSearchParams();
        data.append('model', 'midjourney');
        data.append('taskId', `${taskID}`);
        data.append('customId', `${customId}`);
        data.append('type', 'NORMAL');
        data.append('webhook', WBH);
        data.append('base64Mask', '');
        const ID = event.messageID;
        const resultData = await process(API + "/action", data, message, ID);

        const { taskId: id, imageDcUrl: img } = resultData.data;
        const actions = resultData.data.actions;

        const labelEmojiCId = actions.map(action => ({
          label: action.label,
          emoji: action.emoji,
          customId: action.customId
        }));

        const buttons = labelEmojiCId.map(item => item.label !== '' ? item.label : item.emoji);

        if (resultData.data.status !== "SUCCESS") {
          throw new Error(resultData.data.failReason);
        }

        await message.reply({
          body: `TaskID: ${id}\nAvailable Actions: ${buttons.join(',')}\n\nLink: ${img}`,
          attachment: await getStreamFromURL(img),
        }, async (err, info) => {
          if (err) {
            console.error(err);
            message.reply(`Error: ${err.message}`);
            return;
          }

          message.reaction('✅', event.messageID);
          global.GoatBot.onReply.set(info.messageID, {
            commandName: this.config.name,
            messageID: info.messageID,
            author: event.senderID,
            type: "reply",
            taskId: id,
            buttons: buttons,
            akash: labelEmojiCId
          });
        });
      } else if (type === "describe") {
        const promptText = prompts;
        const promptSplit = promptText.split('\n\n').map(prompt => prompt.trim());
        const action = body;
        if (action !== 0 && action < 5) {
          const promptNE = promptSplit[action - 1].substring(3);
          message.reply(promptNE);
        } else {
          return;
        }
      }
    } catch (error) {
      console.error(error);
      return message.reply(`Error: ${error.message || "Unknown error"}`);
    }
  },
};

async function convert(imageUrl) {
  try {
    const response = await axios.get(imageUrl, {
      responseType: 'arraybuffer'
    });
    const base64 = Buffer.from(response.data, 'binary').toString('base64');
    const dataUrl = `data:image/webp;base64,${base64}`;
    return dataUrl;
  } catch (error) {
    throw new Error(error);
  }
}

function getCustomId(labelOrEmoji, Ids) {
  const item = Ids.find(item => item.label === labelOrEmoji || item.emoji === labelOrEmoji);
  return item ? item.customId : "Not found";
}

async function process(url, data, message, ID) {
  try {
    const response = await axios.post(url, data, {
      headers: {
        'User-Agent': 'Apifox/1.0.0 (https://apifox.com)',
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': `Bearer ${key}`
      }
    });

    if (response.data.statusCode !== 200) {
      throw new Error(response.data.error || response.data.message || "Unknown Error");
    }

    const taskId = response.data.data;
    message.reply("Processing your request...\n\nID: " + taskId);
    message.reaction('⚙', ID);
    const resultData = await Insight(taskId);

    return resultData;
  } catch (error) {
    throw new Error(error);
  }
}

async function Insight(taskId) {
  const url = API + "/query";
  try {
    while (true) {
      const res = await axios.post(url, {
        model: 'midjourney',
        taskId: taskId.toString()
      }, {
        headers: {
          'User-Agent': 'Apifox/1.0.0 (https://apifox.com)',
          'Authorization': `Bearer ${key}`
        }
      });;

      if (res.data.data.status === "SUCCESS" && res.data.data.progress === "100%" || res.data.status === "FAILURE") {
        return res.data;
      }

      await new Promise(resolve => setTimeout(resolve, 20000));
    }
  } catch (error) {
    console.error("Error fetching result:\n" + error.message);
    throw error;
  }
}