const fs = require("fs");
const request = require("request");

module.exports = {
  config: {
    name: "pfp",
    aliases: ["profile"],
    version: "1.0",
    author: "Eijah Noah",
    role: 0,
    category: "image",
    guide: { en: "{pn} <uid>" } },
  
  onStart: async function ({ event, message, usersData, args }) {
    const { threadID, messageID, senderID, body } = event;
    let id;
    if (args.join().includes('@')) {
      id = Object.keys(event.mentions);
    } else {
      id = args[0] || senderID;
    }

    if (event.type === "message_reply") {
      id = event.messageReply.senderID;
    }

    const avatarUrl = await usersData.getAvatarUrl(id);

    message.reply({
      body: "",
      attachment: await global.utils.getStreamFromURL(avatarUrl)
    });
  }
};