const axios = require("axios");

module.exports = {
    config: {
        name: "miu",
        countDown: 10,
        author: "Akash Xzh",
        category: "ai imagination",
        role: 0,
        guide: {
            en: "Usage: {pn} prompt\nExample: {pnt} cute girl --ar 2:3\n\nSupported ratios: 1:1, 2:3, 3:2"
        }
    },
    onStart: async function ({ args, event, message }) {
        try {
            setTimeout(() => {
                message.reaction("⏳", event.messageID);
            }, 700);

            const text = args.join(" ");
            if (!text) {
                return message.reply("Please provide a prompt.");
            }

            message.reply("✅ | Processing your image......");

            const prompt = text.includes("--ar") ? text.split("--ar ")[0] : text;
            let ratio;

            switch (true) {
                case text.includes("--ar 1:1"):
                    ratio = 1;
                    break;
                case text.includes("--ar 2:3"):
                    ratio = 3;
                    break;
                case text.includes("--ar 3:2"):
                    ratio = 2;
                    break;
                default:
                    ratio = 1;
                    break;
            }

            const response = await axios.post(
                'https://api.replicate.com/v1/predictions',
                {
                    'version': '7d6a2f9c4754477b12c14ed2a58f89bb85128edcdd581d24ce58b6926029de08',
                    'input': {
                        'prompt': prompt,
                        'negative_prompt': '',
                        'width': getWidth(ratio),
                        'height': getHeight(ratio),
                        "num_outputs": 1,
                        
"lora_weights": "https://huggingface.co/roktimsardar123/miu/resolve/main/trained_model%20(1).tar?download=true",

        "lora_scale": 0.63,

"num_inference_steps": 30,
                        "guidance_scale": 6,
                        "scheduler": "K_EULER_ANCESTRAL",

"disable_safety_checker": true
                    }
                },
                {
                    headers: {
                        'Content-Type': 'application/json',
                        'Authorization': 'Token r8_80lNb8AwpEemw9n39hGmIaUKvwF86WG3ruxIG'
                    },
                    validateStatus: status => true
                }
            );

            const getUrl = response.data.urls.get;
            let output = null;

            while (!output) {
                const poll = await axios.get(getUrl, {
                    headers: {
                        'Authorization': 'Token r8_80lNb8AwpEemw9n39hGmIaUKvwF86WG3ruxIG'
                    }
                });

                output = poll.data.output;
            }

            let streams = [];

            for (let i of output) {
                const s = await global.utils.getStreamFromURL(i);
                streams.push(s);
            }

            await message.reply({
                body: "Image generated.",
                attachment: streams,
            });

            message.reaction("✅", event.messageID);
        } catch (error) {
            console.error(error);
            await message.reply(`Error: ${error}`);
        }
    }
};

function getWidth(ratio) {
    const widths = [1024, 1024, 1024];
    return widths[ratio - 1] || 1024;
}

function getHeight(ratio) {
    const heights = [1024, 640, 1344];
    return heights[ratio - 1] || 1024;
}