const fs = require('fs');
const axios = require('axios');
const path = require('path');

const model = [
  "dreamshaperXL10_alpha2.safetensors [c8afe2ef]",
  "dynavisionXL_0411.safetensors [c39cc051]",
  "juggernautXL_v45.safetensors [e75f5471]",
  "realismEngineSDXL_v10.safetensors [af771c3f]",
  "sd_xl_base_1.0.safetensors [be9edd61]"
];

module.exports = {
  config: {
    name: 'sdxl',
    version: '1.0',
    author: 'JARiF@একটু পাত্তা দওনা চেটে চেটে খাব',
    countDown: 50,
    role: 0,
    category: 'odof',
    guide: {
      vi: '',
      en: "1. DreamshaperXL10\n2. DynavisionXL\n3. JuggernautXL\n4. RealismEngineSDXL\n5. Sdxl 1.0", 
    },
  },

  onStart: async function ({ event, api, args, message }) {
      const [prompt, modelNumber] = args.slice(1).join(' ').split('|').map((str) => str.trim());

    // Change the selectedModelIndex to 5 for the fifth model (Sdxl 1.0)
    const selectedModelIndex = 5;
    const selectedModel = model[selectedModelIndex - 1] || model[0];

    message.reply('✅ | Please wait...', async (err, info) => {
      if (err) {
        console.error(err);
        return;
      }

      const api_key = '1e3c8331-b94b-4fbe-9e08-e322d67e99a2';

      async function generateImage(prompt, selectedModel) {
        try {
          const options = {
            method: 'POST',
            url: 'https://api.prodia.com/v1/sdxl/generate',
            headers: {
              accept: 'application/json',
              'content-type': 'application/json',
              'X-Prodia-Key': api_key,
            },
            data: {
              prompt: prompt,
              model: selectedModel, 
              negative_prompt: 'sketches, (worst quality, bad quality, cropped:2.0) ((monochrome)), ((grayscale)), (bad-hands-5:1.0), (badhandv4:1.0), (easynegative:0.8),  (bad-artist-anime:0.8), (bad-artist:0.8), (bad_prompt:0.8), (bad-picture-chill-75v:0.8), (bad_prompt_version2:0.8),  (bad_quality:0.8)',
              steps: 50,
              cfg_scale: 7,
              seed: -1,
              upscale: true,
              sampler: 'DPM++ SDE Karras',
              aspect_ratio: 'square',
            },
          };

          const response = await axios(options);
          const job = response.data.job;

          while (true) {
            const jobResponse = await axios.get(
              `https://api.prodia.com/v1/job/${job}`,
              {
                headers: {
                  accept: 'application/json',
                  'X-Prodia-Key': api_key,
                },
              }
            );

            if (jobResponse.data.status === 'succeeded') {
              const imageUrl = jobResponse.data.imageUrl;
              const imageResponse = await axios.get(imageUrl, {
                responseType: 'arraybuffer',
              });
              return imageResponse.data;
            }

            await new Promise((resolve) => setTimeout(resolve, 500));
          }
        } catch (err) {
          console.error(err);
          throw err;
        }
      }

      try {
        const imageBuffer = await generateImage(prompt, selectedModel);
        const imageFileName = '1.png';
        const imagePath = path.join(__dirname, imageFileName);
        fs.writeFileSync(imagePath, imageBuffer);

        await message.reply(
          {
            body: '✅ | Image generated.', 
            attachment: fs.createReadStream(imagePath),
          },
          event.threadID
        );
      } catch (error) {
        console.error(error);
      }
    });
  },
};
