const { spawn } = require('child_process');
const fs = require('fs');

module.exports = {
  config: {
    name: "segs",
    version: "1.0",
    author: "ChatGPT",
    countDown: 5,
    role: 0,
    shortDescription: "",
    longDescription: "",
    category: "",
    guide: ""
  },

  onStart: async function ({ api, args, message, event, threadsData, usersData, dashBoardData, globalData, threadModel, userModel, dashBoardModel, globalModel, role, commandName, getLang }) {
    const inputFile = args[0];
    const screenshotTime = args[1];

    const outputFileName = generateOutputFileName(inputFile, screenshotTime);

    const ffmpegProcess = spawn('ffmpeg', [
      '-i', inputFile,
      '-ss', screenshotTime,
      '-vframes', '1',
      outputFileName
    ]);

    ffmpegProcess.on('close', (code) => {
      if (code === 0) {
        sendScreenshotReply('Screenshot generated successfully!', outputFileName);
      } else {
        sendScreenshotReply(`Screenshot generation failed with code ${code}`, outputFileName);
      }
    });

    ffmpegProcess.on('error', (err) => {
      sendScreenshotReply(`Error during screenshot generation: ${err}`, outputFileName);
    });

    function sendScreenshotReply(logMessage, outputFileName) {
      console.log(logMessage);

      if (logMessage.startsWith('Screenshot generated successfully')) {
        console.log(`Sending screenshot: ${outputFileName}`);
        message.reply({ attachment: fs.createReadStream(outputFileName) });
      } else {
        message.reply(logMessage);
      }
    }

    function generateOutputFileName(inputFile, screenshotTime) {
      const baseName = inputFile.replace(/\.[^/.]+$/, '');
      const timeComponents = screenshotTime.split(':').join('_');
      return `${baseName}_${timeComponents}.png`;
    }
  }
};