const { getTime } = global.utils;
const fs = require("fs");

let config = {
  name: "stats",
  aliases: [],
  version: 1.0,
  author: "Akash Xzh",
  countDown: 5,
  role: 2,
  shortDescription: {
    en: "."
  },
  longDescription: {
    en: "."
  },
  category: "owner",
  guide: {
    en: "{pn}"
  },
  usageCount: {}
};

function loadUsageCount() {
  try {
    const data = fs.readFileSync('usageCount.json', 'utf8');
    config.usageCount = JSON.parse(data);
    
  } catch (err) {
    console.error('Failed to load usage count:', err);
  }
}

function saveUsageCount() {
  const usageCount = config.usageCount;

  try {
    fs.writeFileSync('usageCount.json', JSON.stringify(usageCount));
    console.log('Usage count saved successfully.');
  } catch (err) {
    console.error('Failed to save usage count:', err);
  }
}

module.exports = {
  config: config,
  onStart: async function ({ api, args, message, event, threadsData, usersData, dashBoardData }) {
    const currentDate = getTime("DD/MM/YYYY");
    message.reply({
      body: `TOP 10 MOST USED COMMANDS\nFROM 22/11/2023 to ${currentDate}\n\n${usageCountToString()}`,
    });
  },
  onChat: async function ({ api, args, message, event, threadsData, dashBoardData }) {
    const { getPrefix } = global.utils;
    const prefix = getPrefix(event.threadID);
    const cmd = event.body;
    if (cmd.startsWith(prefix)) {
      const command = cmd.split(' ')[0].substring(prefix.length);
      incrementUsageCount(command);
    }
  }
};

function incrementUsageCount(command) {
  if (!config.usageCount[command]) {
    config.usageCount[command] = 1;
  } else {
    config.usageCount[command]++;
  }

  saveUsageCount();
}

function usageCountToString() {
  const usageCount = config.usageCount;

  const sortedCommands = Object.entries(usageCount)
    .filter(([command, count]) => command !== "")
    .sort((a, b) => b[1] - a[1])
    .slice(0, 10);

  let result = "";
  for (let i = 0; i < sortedCommands.length; i++) {
    const [command, count] = sortedCommands[i];
    result += `${i + 1}. ${command}: ${count}\n`;
  }
  return result;
}

loadUsageCount();