
const surahs = [
  "Al-Fatihah", "Al-Baqarah", "Al-Imran", "An-Nisa", "Al-Maidah", "Al-An'am", "Al-A'raf", "Al-Anfal", "At-Tawbah", "Yunus",
  "Hud", "Yusuf", "Ar-Ra'd", "Ibrahim", "Al-Hijr", "An-Nahl", "Al-Isra", "Al-Kahf", "Maryam", "Ta-Ha", "Al-Anbiya",
  "Al-Hajj", "Al-Mu'minun", "An-Nur", "Al-Furqan", "Ash-Shu'ara", "An-Naml", "Al-Qasas", "Al-Ankabut", "Ar-Rum",
  "Luqman", "As-Sajdah", "Al-Ahzab", "Saba", "Fatir", "Ya-Sin", "As-Saffat", "Sad", "Az-Zumar", "Ghafir", "Fussilat",
  "Ash-Shura", "Az-Zukhruf", "Ad-Dukhan", "Al-Jathiyah", "Al-Ahqaf", "Muhammad", "Al-Fath", "Al-Hujurat", "Qaf",
  "Adh-Dhariyat", "At-Tur", "An-Najm", "Al-Qamar", "Ar-Rahman", "Al-Waqi'ah", "Al-Hadid", "Al-Mujadilah", "Al-Hashr",
  "Al-Mumtahanah", "As-Saff", "Al-Jumu'ah", "Al-Munafiqun", "At-Taghabun", "At-Talaq", "At-Tahrim", "Al-Mulk", "Al-Qalam",
  "Al-Haqqah", "Al-Ma'arij", "Nuh", "Al-Jinn", "Al-Muzzammil", "Al-Muddaththir", "Al-Qiyamah", "Al-Insan", "Al-Mursalat",
  "An-Naba", "An-Nazi'at", "'Abasa", "At-Takwir", "Al-Infitar", "Al-Mutaffifin", "Al-Inshiqaq", "Al-Buruj", "At-Tariq",
  "Al-A'la", "Al-Ghashiyah", "Al-Fajr", "Al-Balad", "Ash-Shams", "Al-Lail", "Ad-Duha", "Al-Inshirah", "At-Tin", "Al-'Alaq",
  "Al-Qadr", "Al-Bayyinah", "Az-Zalzalah", "Al-'Adiyat", "Al-Qari'ah", "At-Takathur", "Al-Asr", "Al-Humazah", "Al-Fil",
  "Quraish", "Al-Ma'un", "Al-Kauthar", "Al-Kafirun", "An-Nasr", "Al-Lahab", "Al-Ikhlas", "Al-Falaq", "An-Nas"
];

module.exports = {
  config: {
    name: "surah",
    version: "1.0",
    author: "Eijah Noah",
    countDown: 0,
    role: 0,
    category: "Islam",
    guide: {
      vi: "",
      en:
      "List of Surah's:\n" +
      surahs.map((surah, index) => `${index + 1}. ${surah}`).join("\n")
    },
  },

  onStart: async function ({ message, args }) {
    if (args.length > 0) {
      const surahName = args.join(" ");
      const surahIndex = surahs.findIndex(name => name.toLowerCase() === surahName.toLowerCase());
      
      if (surahIndex === -1) {
        return message.reply("Surah not found.\n List of Surah's:\n" +
        surahs.map((surah, index) => `${index + 1}. ${surah}`).join("\n"));
      }
      
      const surahNumber = surahIndex + 1;
      const surahURL = `https://server8.mp3quran.net/afs/${surahNumber.toString().padStart(3, '0')}.mp3`;
      
      return message.reply({
        body: `Surah: ${surahs[surahIndex]}\nNumber: ( ${surahNumber}th Number Surah )\n\n Total: 114 Surah's`, 
        attachment: await global.utils.getStreamFromURL(surahURL),
      });
    } else {
      const surahNumber = Math.floor(Math.random() * 114); 
      const surahURL = `https://server8.mp3quran.net/afs/${(surahNumber + 1).toString().padStart(3, '0')}.mp3`;
      const surahName = surahs[surahNumber]; 
      
      return message.reply({
        body: `Surah: ${surahName}\nNumber: ( ${surahNumber + 1}th Number Surah )\n\n Total: 114 Surah's`, 
        attachment: await global.utils.getStreamFromURL(surahURL),
      });
    }
  }
};