const axios = require("axios");

module.exports = {
  config: {
    name: "ti",
    aliases: ["tt", "ti", "t3i"],
    version: "1.0",
    author: "JARiF@একটু পাত্তা দওনা চেটে চেটে খাব",
    countDown: 15,
    role: 0,
    shortDescription: {
      vi: "Tạo ảnh từ văn bản của bạn",
      en: "Create image from your text"
    },
    longDescription: {
      uid: "Tạo ảnh từ văn bản của bạn",
      en: "Create image from your text"
    },
    category: "Ai",
    guide: {
      vi: "",
      en:
        "{pn} your prompt | Type\n" +
        "Here are supported models:\n" +
        "1: Imagine V4 Beta,\n" +
        "2: Imagine V4 Creative,\n" +
        "3: Imagine V3,\n" +
        "4: Imagine V1,\n" +
        "5: Portrait,\n" +
        "6: Realistic,\n" +
        "7: Anime,\n" +
        "8: Surrealism,\n" +
        "9: Anime V2,\n" +
        "10: Marble,\n" +
        "11: Cosmic,\n" +
        "12: Minecraft,\n" +
        "13: Disney,\n" +
        "14: GTA,\n" +
        "15: Macro,\n" +
        "16: Studio Ghibli,\n" +
        "17: Dystopian,\n" +
        "18: Gothic"
    }
  },

  langs: {
    vi: {
      syntaxError: "⚠️ Vui lòng nhập prompt",
      error: "❗ Đã có lỗi xảy ra, vui lòng thử lại sau:\n%1",
      serverError: "❗ Server đang quá tải, vui lòng thử lại sau"
    },
    en: {
      syntaxError: "⚠️ Please enter prompt",
      error: "try again later ❗",
      serverError: "❗ Server is overloaded, please try again later"
    }
  },

  onStart: async function ({ message, args, getLang }) {
    const prompt = args.join(" ");
    if (!prompt)
      return message.reply(getLang("syntaxError"));

    message.reply("✅| Creating your Imagination...", (err, info) => { id = info.messageID });

    try {
      const { data: imageStream } = await axios({
        url: "https://goatbotserver.onrender.com/taoanhdep/texttoimage",
        method: "POST",
        headers: {
          "Content-Type": "application/json"
        },
        data: {
          prompt,
          styleId: 28,
          aspect_ratio: "16:9"
        },
        responseType: "stream"
      });

      imageStream.path = "image.jpg";

      return message.reply({
        attachment: imageStream
      });
    } catch (err) {
      return message.reply(getLang("error", err.response?.data?.message || err.message));
    }
  }
};
