const axios = require('axios');

module.exports = {
  config: {
    name: "billie",
    version: "1.1",
    author: "Akash Xzh",
    shortDescription: {
      en: "Not Available"
    },
    longDescription: {
      en: "Not Available"
    },
    category: "Memes",
    countDown: 10,
    role: 0,
    guide: {
      en: "{pn} prompt"
    }
  },

  onStart: async function ({ event, args, message }) {
    try {
      const prompt = args.join(" ");
      if (!prompt) {
        return message.reply("Please provide a prompt.");
      }
      message.reply("Creating...");

      const requestId = randomId();

      const response = await axios.post('https://ap-east-1.tensorart.cloud/v1/jobs', {
        "requestId": requestId,
        "stages": [
          {
            "type": "INPUT_INITIALIZE",
            "inputInitialize": {
              "seed": "-1",
              "count": 1
            }
          },
          {
            "type": "DIFFUSION",
            "diffusion": {
              "width": 1024,
              "height": 1024,
              "prompts": [
                {
                  "text": prompt
                }
              ],
              "negativePrompts": [
                {
                  "text": "lowres, bad anatomy, bad hands, error, missing fingers, saturated"
                }
              ],
              "sdModel": "674369080456901126",
              "sdVae": "Automatic",
              "sampler": "Euler a",
              "steps": 30,
              "cfgScale": 5,
              "clipSkip": 1,
              "etaNoiseSeedDelta": 0,
"lora": {
					"items": [
						{
							"loraModel": "666072724059268954",
							"weight": 0.75
						}
					]
				}
            }
          }
        ],
        "engine": "TAMS_V1"
      }, {
        headers: {
          'Content-Type': 'application/json',
          'Authorization': 'Bearer bf24fae785474f3b8fa3b80bf7153b1d'
        }
      });

      const jobId = response.data.job.id;

      const jobDetails = await JobDetails(jobId);
      if (jobDetails.job.successInfo.images.length > 0) {
        message.reply({
          body: "Here's your image.",
          attachment: await global.utils.getStreamFromURL(jobDetails.job.successInfo.images[0].url)
        });
      } else {
        message.reply("No image found.");
      }

    } catch (error) {
      console.error("Error occurred:", error);
      message.reply(error.message);
    }
  }
};

function randomId() {
  return Math.random().toString(36).substring(2, 15) + Math.random().toString(36).substring(2, 15);
}

async function JobDetails(jobId) {
  try {
    while (true) {
      const response = await axios.get(`https://ap-east-1.tensorart.cloud/v1/jobs/${jobId}`, {
        headers: {
          'Authorization': 'Bearer bf24fae785474f3b8fa3b80bf7153b1d'
        }
      });

      if (response.data.job.status === "SUCCESS") {
        return response.data;
      }

      await new Promise(resolve => setTimeout(resolve, 10000));
    }
  } catch (error) {
    console.error("Error getting job details:", error);
    throw error;
  }
}