let axios = require("axios");

module.exports = {
  config: {
    name: "tg",
    aliases: [`telegraph`],
    version: "1.0",
    author: "Samir Œ",
    countDown: 0,
    role: 0,
    shortDescription: "Get download url from video, audio sent from group",
    longDescription: "Get download url from video, audio sent from group",
    category: "𝗨𝗧𝗜𝗟𝗜𝗧𝗬",
    guide: "{pn} reply or add link of image"
  },

  onStart: async function ({ api, event }) {
    let { messageReply, threadID } = event;

    if (event.type !== "message_reply") {
      return api.sendMessage("❌ You must reply to a certain audio, video, or photo", event.threadID, event.messageID);
    }

    if (!event.messageReply.attachments || event.messageReply.attachments.length == 0) {
      return api.sendMessage("❌ You must reply to a certain audio, video, or photo", event.threadID, event.messageID);
    } else {
      let num = 0;
      let msg = `There is ${messageReply.attachments.length} file attached:\n`;

      for (var i = 0; i < messageReply.attachments.length; i++) {

const shortLink = await global.utils.uploadImgbb(messageReply.attachments[i].url);
      const Url = shortLink.image.url;

        var like = `https://apis-samir.onrender.com/telegraph?url=${encodeURIComponent(Url)}&senderId=${event.senderID}`;

        try {
          let response = await axios.get(like);
          let link = response.data.result.link;

          num += 1;
          msg += `${num}: ${link} \n`;
        } catch (error) {
          console.error("Error fetching link:", error);
          msg += `${num}: Error fetching link\n`;
        }
      }

      api.sendMessage(msg, threadID);
    }
  }
};