const axios = require('axios');
const styles = [
"46846", "232703", "180845", "106922", "64094", "209164", "176425", "93208", "128713", "181914", "179446", "100675", "143906", "119057", "5038", "156263", "75209", "218017", "121557", "89855", "108289", "234105", "86698", "132760", "198401", "115942", "130121", "95489", "224009", "224200", "223670", "130072", "182252", "141866", "160495", "127207", "127416", "112809", "108545", "127680", "90854", "220703", "90599", "181248", "6087", "229575", "166916", "158294", "223684", "142125", "147184", "204878", "189192", "25993", "181191", "124626", "137204", "113391", "6878", "5036", "167841", "224080", "105796", "24129", "137207", "69687", "70977", "158155", "115086", "120036", "101966", "159473", "180919", "114492", "234205", "153135", "84783", "103277", "6792", "89927", "90674", "112825", "208500", "215628", "147336", "229535", "12763", "138124", "232266", "125903", "161429", "110299", "17084", "205925", "220987", "23323", "233820", "53806", "2810071", "45669", "29179", "128046", "5021", "45601", "179525", "23326", "67192", "71733", "14459", "75", "90587", "123908", "207802", "232446", "224916", "139087", "107812", "142506", "43825" ];

module.exports = {
  config: {
    name: "kamla2",
    version: "1.0",
    author: "JARiF@একটু পাত্তা দওনা চেটে চেটে খাব",
    countDown: 10,
    role: 0,
    shortDescription: {
      en: 'Text to Image'
    },
    longDescription: {
      en: "Text to image"
    },
    category: "image",
    guide: {
      en: `1: BASE
2: CINEMATIC
3: 3D-MODEL
4: ANALOG FILM
5: ANIME
6: CINEMATIC
7: COMIC BOOK
8: CRAFT CLAY
9: DIGITAL ART
10: ENHANCE
11: FANTASY ART
12: ISOMETRIC
13: LINE ART
14: LOWPOLY
15: NEONPUNK
16: ORIGAMI
17: PHOTOGRAPHIC
18: PIXEL ART
19: TEXTURE
20: ADVERTISING
21: AUTOMOTIVE
22: CORPORATE
23: FASHION EDITORIAL
24: FOOD PHOTOGRAPHY
25: LUXURY
26: REAL ESTATE
27: RETAIL
28: ABSTRACT
29: ABSTRACT EXPRESSIONISM
30: ART DECO
31: ART NOUVEAU
32: CONSTRUCTIVIST
33: CUBIST
34: EXPRESSIONIST
35: GRAFFITI
36: HYPERREALISM
37: IMPRESSIONIST
38: POINTILLISM
39: POP ART
40: PSYCHEDELIC
41: RENAISSANCE
42: STEAMPUNK
43: SURREALIST
44: TYPOGRAPHY
45: WATERCOLOR
46: BIOMECHANICAL
47: BIOMECHANICAL CYBERPUNK
48: CYBERNETIC
49: CYBERNETIC ROBOT
50: CYBERPUNK CITYSCAPE
51: FUTURISTIC
52: RETRO CYBERPUNK
53: RETRO FUTURISM
54: SCI-FI
55: VAPORWAVE
56: BUBBLE BOBBLE
57: CYBERPUNK GAME
58: FIGHTING GAME
59: GTA
60: MARIO
61: MINECRAFT
62: POKEMON
63: RETRO ARCADE
64: RETRO GAME
65: RPG FANTASY GAME
66: STRATEGY GAME
67: STREETFIGHTER
68: ZELDA
69: ARCHITECTURAL
70: DISCO
71: DREAMSCAPE
72: DYSTOPIAN
73: FAIRY TALE
74: GOTHIC
75: GRUNGE
76: HORROR
77: KAWAII
78: LOVECRAFTIAN
79: MACABRE
80: MANGA
81: METROPOLIS
82: MINIMALIST
83: MONOCHROME
84: NAUTICAL
85: SPACE
86: STAINED GLASS
87: TECHWEAR FASHION
88: TRIBAL
89: ZENTANGLE
90: COLLAGE
91: FLAT PAPERCUT
92: KIRIGAMI
93: PAPER MACHE
94: PAPER QUILLING
95: PAPERCUT COLLAGE
96: PAPERCUT SHADOW BOX
97: STACKED PAPERCUT
98: THICK LAYERED PAPERCUT
99:  ALIEN
100: FILM NOIR
101: HDR
102: LONG EXPOSURE
103: NEON NOIR
104: SILHOUETTE
105: TILT-SHIFT`,
    }
  },

  onStart: async function ({ message, args }) {
    const text = args.join(" ");
    if (!text) {
      return message.reply("Please provide a prompt.");
    }

    let prompt, selectedStyle;
    if (text.includes("|")) {
      const [promptText, styleInput] = text.split("|").map((str) => str.trim());
      prompt = promptText;

      if (!isNaN(styleInput)) {
        const styleNumber = parseInt(styleInput);
        if (styleNumber >= 1 && styleNumber <= styles.length) {
          selectedStyle = styles[styleNumber - 1];
        } else {
          return message.reply("Invalid style number. Please use a valid number from the guide.");
        }
      } else {
        return message.reply("Invalid style input. Please use a valid style number from the guide.");
      }
    } else {
      prompt = text;
      selectedStyle = "46846";
    }
    const waitingMessage = await message.reply(selectedStyle);

    try {
      const API = `https://idolizedyellowgreenengineering.brokenx69.repl.co/gen?prompt=${encodeURIComponent(prompt)}&model=${selectedStyle}`;
      const response = await axios.get(API);

      const imageStream = await global.utils.getStreamFromURL(response.data.image);

      await message.reply({
        attachment: imageStream,
      });
    } catch (error) {
      message.reply(error.message).then(() => {
       message.unsend(waitingMessage);
      });
    }
  },
};