import os
import zipfile

def zip_current_folder():
    # Get the current folder path
    current_folder = os.getcwd()
    # Define the zip file name
    zip_file_name = os.path.basename(current_folder) + '.zip'

    # Create a zip file
    with zipfile.ZipFile(zip_file_name, 'w', zipfile.ZIP_DEFLATED) as zipf:
        # Walk through all the files and folders in the current directory
        for root, dirs, files in os.walk(current_folder):
            for file in files:
                # Create the full file path
                file_path = os.path.join(root, file)
                # Add file to zip file, removing the current folder path to maintain relative paths
                zipf.write(file_path, os.path.relpath(file_path, current_folder))

if __name__ == "__main__":
    zip_current_folder()
    print("Current folder zipped successfully.")